if exists (select * from sysobjects where id = object_id('DBA_HelpFK'))
begin
	drop function DBA_HelpFK
end
go
Create Function DBA_HelpFK 
(@pvcTableName varchar(1000)
,@pvcSchemaName varchar(100) )  
RETURNS @tbFKInfo  TABLE       
 (        
  ForeignKeyName varchar(100) NOT NULL,        
  FKTableName varchar(100) NOT NULL,   
  FKSchemaName varchar(100) NOT NULL,
  FKCols varchar(800),  
  PKTableName varchar(1000) NOT NULL, 
  PKSchemaName varchar(100) NOT NULL,  
  PKCols varchar(800)  ,
 DELETE_REFERENTIAL_ACTION_DESC varchar(100) NOT NULL,
 UPDATE_REFERENTIAL_ACTION_DESC varchar(100) NOT NULL
 )        
AS      
BEGIN   
DECLARE @tFKInfo TABLE (  
 [ForeignKeyName] [varchar] (128) NOT NULL ,  
 [KeyNo] [smallint] NOT NULL ,  
 [FKTableName] [nvarchar] (128) NOT NULL ,  
  FKSchemaName varchar(100) NOT NULL,
 [FKColName] [sysname] NOT NULL ,  
 [PKTableName] [varchar] (128) NOT NULL ,  
 PKSchemaName varchar(100) NOT NULL,
 [PKColName] [sysname] NOT NULL   ,
 DELETE_REFERENTIAL_ACTION_DESC varchar(100) NOT NULL,
 UPDATE_REFERENTIAL_ACTION_DESC varchar(100) NOT NULL
)  
  
INSERT INTO @tFKInfo   
  SELECT object_name(constid) as ForeignKeyName
,fk.keyno as KeyNo
, object_name(cc.id) as FKTableName
,schema_name (c_sysobjects.schema_id)as FKSchemaName
,cc.name as FKColName
,object_name(pc.id) as PKTableName
,schema_name (p_sysobjects.schema_id) as PKSchemaName
,pc.name as PKColName  
,sfk.DELETE_REFERENTIAL_ACTION_DESC
,sfk.UPDATE_REFERENTIAL_ACTION_DESC
  from sysforeignkeys fk  
  inner join syscolumns pc  
  on fk.rkeyid=pc.id  
  --and fk.keyno=pc.colid  
	and fk.rkey = pc.colid
  inner join syscolumns cc  
  on fk.fkeyid=cc.id  
  and fk.fkey=cc.colid  
	inner join sys.foreign_keys sfk
	on sfk.object_id = fk.constid
	inner join sys.objects c_sysobjects
	on cc.id = c_sysobjects.object_id
	inner join sys.objects p_sysobjects
	on pc.id = p_sysobjects.object_id
  where object_name(fkeyid)=@pvcTableName  
	and sfk.schema_id = schema_id(@pvcSchemaName);


declare @i int  
declare @vcForeignKeyName varchar(100)  
declare @iMaxKeyNo int  
declare curFK cursor for select ForeignKeyName, max(KeyNo) from @tFKInfo GROUP BY ForeignKeyName  
open curFK  
fetch curFK into @vcForeignKeyName, @iMaxKeyNo  
WHILE @@FETCH_STATUS=0  
BEGIN  
   IF @iMaxKeyNo > 1  
   BEGIN  
      SET @i=1  
      WHILE @i < @iMaxKeyNo  
      BEGIN  
         SELECT @i=@i+1  
  
         UPDATE t1   
            SET FKCOlName=t1.FKColName+','+t2.FKColName  
              , PKCOlName=t1.PKColName+','+t2.PKColName  
            FROM @tFKInfo t1  
            INNER JOIN @tFKInfo t2  
            ON t1.ForeignKeyName=t2.ForeignKeyName and t2.KeyNo=@i  
            WHERE t1.ForeignKeyName = @vcForeignKeyName  
            AND t1.KeyNo=1  
      END  
   END    
   fetch curFK into @vcForeignKeyName, @iMaxKeyNo  
END  
close curFK  
deallocate curFK  
  
INSERT INTO @tbFKInfo  
   SELECT ForeignKeyName, FKTableName, FKSchemaName, FKColName, PKTableName, PKSchemaName,PKColName,DELETE_REFERENTIAL_ACTION_DESC,UPDATE_REFERENTIAL_ACTION_DESC  
   FROM @tFKInfo  
   WHERE KeyNo=1  
  
RETURN  
  
END  
