if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBA_HelpIndex]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[DBA_HelpIndex]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE  function DBA_HelpIndex 
( @pvcTableName varchar(100)
, @pvcSchemaName varchar(100) )  
RETURNS @tbIndexInfo  TABLE   
 (    
  IndexName	varchar(1000) NOT NULL,    
  StatusCode	int,    
  IsPrimaryKey	char(1),  
  IsClustered	char(1),  
  IsUnique	char(1),  
  IndexKeys	varchar(4000)
 )    
AS  
BEGIN  
declare @objid int,   -- the object id of the table    
	@indid smallint, -- the index id of an index    
	@groupid smallint,  -- the filegroup id of an index    
	@indname sysname,    
	@groupname sysname,    
	@status int,    
	@keys nvarchar(2126)  
	,@fully_qualified_TableName varchar(2000)

select @fully_qualified_TableName = @pvcSchemaName + '.' + @pvcTableName

declare @i int, 
	@thiskey varchar(131) -- 128+3    

    
declare ms_crs_ind cursor local static for    
  select si.indid, si.groupid, si.name, si.status 
    from sysindexes  si
	join sys.objects so
	on si.id = so.object_id  
    where object_name(si.id)=@pvcTableName 
    and si.indid > 0 and si.indid < 255 
    and (si.status & 64)=0
	and so.schema_id = schema_id(@pvcSchemaName)
    order by si.indid    

  
open ms_crs_ind    
fetch ms_crs_ind into @indid, @groupid, @indname, @status    
  
while @@fetch_status >= 0    
begin    
  select @keys = index_col(@fully_qualified_TableName, @indid, 1), @i = 2    
  if (indexkey_property(@objid, @indid, 1, 'isdescending') = 1)    
    select @keys = @keys  + '(-)'    
    
  select @thiskey = index_col(@fully_qualified_TableName, @indid, @i)    
  if ((@thiskey is not null) and (indexkey_property(@objid, @indid, @i, 'isdescending') = 1))    
   select @thiskey = @thiskey + '(-)'    
    
  while (@thiskey is not null )    
  begin    
   select @keys = @keys + ', ' + @thiskey, @i = @i + 1    
   select @thiskey = index_col(@fully_qualified_TableName, @indid, @i)    
   if ((@thiskey is not null) and (indexkey_property(@objid, @indid, @i, 'isdescending') = 1))    
    select @thiskey = @thiskey + '(-)'    
  end    
    
  --select @groupname = groupname from sysfilegroups where groupid = @groupid    
    
  -- INSERT ROW FOR INDEX    
  insert into @tbIndexInfo (IndexName,StatusCode, IndexKeys)  
    values (@indname, @status, replace(@keys,' ','')) 
    
  -- Next index    
  fetch ms_crs_ind into @indid, @groupid, @indname, @status    
end    
deallocate ms_crs_ind    
  
update @tbIndexInfo   
   set IsClustered=case when (StatusCode & 16)<>0 then 'Y' else 'N' end  ,  
 IsUnique=case when (StatusCode & 2)<>0 then 'Y' else 'N' end  ,  
 IsPrimaryKey=case when (StatusCode & 2048)<>0 then 'Y' else 'N' end    
  
RETURN    
END    
  

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
