if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DBA_IndexRebuild]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[DBA_IndexRebuild]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE DBA_IndexRebuild 

AS
/*
runs ALTER INDEX REBUILD
procedure is highly customized due to the unique nature of PCMX...namely the GUIDs

*/
SET NOCOUNT ON

--get me a table to manipulate later
select * 
into #defrag_before
from sys.dm_db_index_physical_stats(db_id(),NULL,NULL,NULL,NULL)

declare dave cursor for 
	select 
		'ALTER INDEX ' + i.name + ' ON ' + SCHEMA_NAME(o.schema_id) + '.' + OBJECT_NAME(tmp.OBJECT_ID) + ' REBUILD WITH (FillFactor = 80)'
	from #defrag_before tmp
	left join sys.objects o on tmp.object_id = o.object_id
	left join sys.indexes i on tmp.object_id = i.object_id and tmp.index_id = i.index_id
	where tmp.avg_fragmentation_in_percent > 10
	and page_count > 8
	and i.name is not null
	order by tmp.index_type_desc, OBJECT_NAME(tmp.OBJECT_ID)
declare @exec_str varchar(max)
open dave
fetch next from dave into @exec_str
while @@FETCH_STATUS = 0
begin
	PRINT @exec_str
	EXEC (@exec_str)
	fetch next from dave into @exec_str
end
close dave
deallocate dave


GO

