if exists (select * from sysobjects where type = 'P' and id = object_id('DBA_ManipulateForeignKeys'))
begin
	drop proc DBA_ManipulateForeignKeys
end 
go
CREATE PROC DBA_ManipulateForeignKeys
(@operation varchar(10)
,@tablename sysname
,@schemaName sysname
)
AS

/*
either disables all enabled constraints on the given table or
enables all disabled constraints on the given table.  
*/
BEGIN
SET NOCOUNT ON  

--DECLARE @operation VARCHAR(10)  
--DECLARE @tableName sysname  
--DECLARE @schemaName sysname  

--SET @operation = 'DROP' --ENABLE, DISABLE, DROP  
--SET @tableName = 'SpecialOfferProduct'  
--SET @schemaName = 'Sales'  

DECLARE @cmd NVARCHAR(1000) , @FK_NAME varchar(200)


DECLARE cursor_fkeys CURSOR FOR   
	select fk.name 
	from sys.foreign_keys fk
	join sys.objects o on fk.parent_object_id = o.object_id
	where o.name  = @tablename
	and o.schema_id = schema_id(@SCHEMANAME)

OPEN cursor_fkeys  

FETCH NEXT FROM   cursor_fkeys   
   INTO @FK_NAME
WHILE @@FETCH_STATUS = 0   
BEGIN   

   -- create statement for enabling FK  
   IF @operation = 'ENABLE'   
   BEGIN  
       SET @cmd = 'ALTER TABLE [' + @schemaName + '].[' + @tablename   
           + ']  CHECK CONSTRAINT [' + @FK_NAME + ']'  

      PRINT @cmd  
   END  

   -- create statement for disabling FK  
   IF @operation = 'DISABLE'  
   BEGIN     
       SET @cmd = 'ALTER TABLE [' + @schemaName + '].[' + @tablename   
           + ']  NOCHECK CONSTRAINT [' + @FK_NAME + ']'  

      PRINT @cmd  
   END  


	EXEC (@cmd)

   FETCH NEXT FROM    cursor_fkeys   
      INTO @FK_NAME
END  

CLOSE cursor_fkeys   
DEALLOCATE cursor_fkeys 

END