IF EXISTS (select * from sysobjects where id = object_id('DBA_SplitStrings'))
begin
	drop function DBA_SplitStrings
end
go

CREATE FUNCTION DBA_SplitStrings (@vcColList Varchar(4000))  
RETURNS   
@ParsedList table   
(  
   ColumnName varchar(64)  
)   
AS  
BEGIN  
 DECLARE   
  @ColumnName varchar(4000),  
  @Pos int  
  
 SET @vcColList = LTRIM(RTRIM(@vcColList))+','  
 SET @Pos = CHARINDEX(',',@vcColList,1)  
  
 If REPLACE(@vcColList, ',' , ' ') <> ''  
 BEGIN  
  WHILE @Pos > 0  
  BEGIN   
   SET @ColumnName = LTRIM(RTRIM(LEFT(@vcColList, @Pos -1)))  
   IF @ColumnName <> ''  
   BEGIN  
    INSERT into @ParsedList (ColumnName) values (@ColumnName)  
   END  
   SET @vcColList = RIGHT(@vcColList, LEN(@vcColList) - @Pos)  
   SET @Pos = CHARINDEX (',',@vcColList,1)  
  END  
 END  
 RETURN  
END  
  
