---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Addresses]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[Addresses](
	[AddressOID] [int] NOT NULL,
	[ContactOID] [int] NOT NULL,
	[Ordinal] [int] NOT NULL,
	[AddressOne] [nvarchar](50) NULL,
	[AddressTwo] [nvarchar](50) NULL,
	[City] [nvarchar](50) NULL,
	[State] [nchar](2) NULL,
	[Zip] [nvarchar](15) NULL,
	[PhoneOne] [nvarchar](10) NULL,
	[ExtOne] [nvarchar](10) NULL,
	[PhoneTwo] [nvarchar](10) NULL,
	[ExtTwo] [nvarchar](10) NULL,
	[Mobile] [nvarchar](10) NULL,
	[Pager] [nvarchar](10) NULL,
	--[PagerPIN] [nvarchar](10) NULL
) ON [PRIMARY]
END;
EXEC DBA_PortingAddorAlterColumn @pvcTableName = 'Addresses', 
								@pvcSchemaName = 'dbo',
								@pvcColumnName = 'PagerPIN',
								@pvcDataTypeText = 'varchar',
								@pvcLength = 10,
								@pvcPrecision = NULL,
								@pvcScale = NULL,
								@pvcNullable = 'NULL',
								@DeleteCol =  0	;



