---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Alert]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[Alert](
	[AlertOID] [int] NOT NULL,
	[AlertTypeOID] [int] NOT NULL,
	[AlertLevelOID] [int] NOT NULL,
	[AlertLevelSnapshot] [nvarchar](100) NOT NULL,
	[AlertDateTime] [datetime] NOT NULL,
	[AlertDateTimeGMTOffset] [int] NOT NULL,
	[CriteriaSnapshot] [nvarchar](255) NOT NULL,
	[CreatedByContactOID] [int] NULL,
	[PatientResultOID] [int] NULL,
	[PatientOID] [int] NOT NULL,
	[LastEscalation] [datetime] NULL,
	[NextEscalation] [datetime] NULL,
	[EscalationCount] [int] NOT NULL,
	[EscalationType] [int] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.Alert already exists, performing Alters (if required)...'

END --ALTERS  
GO  

