---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[AlertLevels]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[AlertLevels](
	[AlertLevelOID] [int] NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[LevelColor] [char](6) NOT NULL,
	[Description] [nvarchar](100) NULL,
	[Icon] [nvarchar](50) NULL,
	[SequenceNumber] [int] NOT NULL,
	[EnableAlertEscalation] [bit] NOT NULL,
	[EnableIntraContactEscalation] [bit] NOT NULL,
	[EscalationInterval] [int] NOT NULL,
	[ResultStatusFilter] [int] NOT NULL,
	[Enabled] [bit] NOT NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.AlertLevels already exists, performing Alters (if required)...'

END --ALTERS  
GO  

