---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[AlertNote]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[AlertNote](
	[AlertNoteOID] [int] NOT NULL,
	[AlertOID] [int] NOT NULL,
	[ContactOID] [int] NOT NULL,
	[NoteText] [nvarchar](max) NOT NULL,
	[CreateDateTime] [datetime] NOT NULL,
	[CreateDateTimeGMTOffset] [int] NOT NULL,
	[ProxyContactOID] [int] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.AlertNote already exists, performing Alters (if required)...'

END --ALTERS  
GO  

