---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[AlertNotificationLog]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[AlertNotificationLog](
	[AlertNotificationLogOID] [int] NOT NULL,
	[AlertOID] [int] NOT NULL,
	[DateTimeSent] [datetime] NOT NULL,
	[DateTimeSentGMTOffset] [int] NOT NULL,
	[ContactOID] [int] NOT NULL,
	[CommMethodOID] [int] NULL,
	[CommMethodSnapshot] [nvarchar](1000) NOT NULL,
	[NextCheck] [datetime] NULL,
	[WorkstationNotify] [bit] NOT NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.AlertNotificationLog already exists, performing Alters (if required)...'

END --ALTERS  
GO  

