---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[AlertResponseLog]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[AlertResponseLog](
	[AlertResponseLogOID] [int] NOT NULL,
	[AlertOID] [int] NOT NULL,
	[ResponseDateTime] [datetime] NOT NULL,
	[ResponseDateTimeGMTOffset] [int] NOT NULL,
	[AlertStatusID] [int] NOT NULL,
	[Comment] [nvarchar](2000) NULL,
	[ContactOID] [int] NOT NULL,
	[ProxyContactOID] [int] NULL,
	[NoteVoice] [image] NULL,
	[AlertAckVoice] [image] NULL,
	[ListenedTo] [timestamp] NULL,
	[PartialListen] [int] NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.AlertResponseLog already exists, performing Alters (if required)...'

END --ALTERS  
GO  

