---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[AlertWorklists]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[AlertWorklists](
	[AlertWorklistOID] [int] NOT NULL,
	[ContactOID] [int] NULL,
	[Name] [nvarchar](50) NOT NULL,
	[Filter] [xml] NOT NULL,
	[ColAlertStatus] [int] NULL,
	[ColLastResponse] [int] NULL,
	[ColEscalationLevel] [int] NULL,
	[ColLastEscalation] [int] NULL,
	[ColNextEscalation] [int] NULL,
	[ColExam] [int] NULL,
	[ColResultStatus] [int] NULL,
	[ColPatientName] [int] NULL,
	[ColMRN] [int] NULL,
	[ColAccount] [int] NULL,
	[ColAdmitting] [int] NULL,
	[ColAttending] [int] NULL,
	[ColAdmitType] [int] NULL,
	[ColAdmitClass] [int] NULL,
	[ColLocation] [int] NULL,
	[ColLastUpdate] [int] NULL,
	[ColDateOfBirth] [int] NULL,
	[ColAge] [int] NULL,
	[ColHeight] [int] NULL,
	[ColWeight] [int] NULL,
	[ColGender] [int] NULL,
	[ColPregnant] [int] NULL,
	[ColLMP] [int] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.AlertWorklists already exists, performing Alters (if required)...'

END --ALTERS  
GO  

