---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Contacts]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[Contacts](
	[ContactOID] [int] NOT NULL,
	[Status] [char](1) NOT NULL,
	[UserOID] [int] NULL,
	[ExternalID] [nvarchar](50) NULL,
	[FirstName] [nvarchar](40) NOT NULL,
	[MiddleName] [nvarchar](20) NULL,
	[LastName] [nvarchar](40) NOT NULL,
	[Prefix] [nvarchar](10) NULL,
	[Suffix] [nvarchar](10) NULL,
	[Title] [nvarchar](20) NULL,
	[DrTitle] [nvarchar](10) NULL,
	[CanViewVIP] [bit] NOT NULL,
	[DoesTimeout] [bit] NOT NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.Contacts already exists, performing Alters (if required)...'

END --ALTERS  
GO  

