---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[InterfaceDefinitions]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[InterfaceDefinitions](
	[InterfaceDefinitionOID] [int] NOT NULL,
	[InterfaceName] [nvarchar](8) NOT NULL,
	[Description] [nvarchar](200) NOT NULL,
	[IsModel] [bit] NOT NULL,
	[ParentDefinitionOID] [int] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.InterfaceDefinitions already exists, performing Alters (if required)...'

END --ALTERS  
GO  

