---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[InterfaceFieldActions]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[InterfaceFieldActions](
	[InterfaceMessageDefinitionOID] [int] NOT NULL,
	[FieldName] [nvarchar](50) NOT NULL,
	[FieldAction] [nvarchar](20) NOT NULL,
	[ActionParam1] [nvarchar](12) NULL,
	[ActionParam2] [nvarchar](12) NULL,
	[ActionParam3] [nvarchar](12) NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.InterfaceFieldActions already exists, performing Alters (if required)...'

END --ALTERS  
GO  

