---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[InterfaceFieldMappings]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[InterfaceFieldMappings](
	[InterfaceMessageDefinitionOID] [int] NOT NULL,
	[FieldName] [nvarchar](50) NOT NULL,
	[FieldType] [nvarchar](10) NOT NULL,
	[FieldSubType] [nvarchar](10) NULL,
	[SegmentName] [nvarchar](3) NOT NULL,
	[SegmentLocation] [nvarchar](2) NOT NULL,
	[FieldPosition] [int] NULL,
	[ComponentPosition] [int] NULL,
	[DescriptorValue] [nvarchar](20) NULL,
	[DescriptorFieldPosition] [int] NULL,
	[DescriptorComponentPosition] [int] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.InterfaceFieldMappings already exists, performing Alters (if required)...'

END --ALTERS  
GO  

