---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LookupValues]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[LookupValues](
	[LookupValueOID] [int] NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[Description] [nvarchar](255) NULL,
	[Abbreviation] [nvarchar](50) NULL,
	[LookupValueGroupOID] [int] NOT NULL,
	[SequenceNumber] [int] NOT NULL,
	[AdditionalData] [nvarchar](100) NULL,
	[IsDefault] [bit] NOT NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.LookupValues already exists, performing Alters (if required)...'

END --ALTERS  
GO  

