---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PatientAllergies]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[PatientAllergies](
	[PatientOID] [uniqueidentifier] NOT NULL,
	[Type] [nvarchar](50) NOT NULL,
	[Description] [nvarchar](100) NOT NULL,
	[Severity] [uniqueidentifier] NOT NULL,
	[Reaction] [nvarchar](50) NULL,
	[OnsetDT] [smalldatetime] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.PatientAllergies already exists, performing Alters (if required)...'

END --ALTERS  
GO  

