---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PatientContacts]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[PatientContacts](
	[PatientContactOID] [int] NOT NULL,
	[PatientContactType] [nvarchar](10) NOT NULL,
	[ContactID] [nvarchar](50) NOT NULL,
	[LastName] [nvarchar](50) NOT NULL,
	[FirstName] [nvarchar](50) NOT NULL,
	[MiddleName] [nvarchar](50) NULL,
	[Prefix] [nvarchar](50) NULL,
	[Suffix] [nvarchar](50) NULL,
	[Title] [nvarchar](50) NULL,
	[PatientOID] [int] NOT NULL,
	[ContactOID] [int] NULL,
	[ProviderRoleOID] [int] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.PatientContacts already exists, performing Alters (if required)...'

END --ALTERS  
GO  

