---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PatientExams]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[PatientExams](
	[ExamOID] [int] NOT NULL,
	[Entity] [nvarchar](6) NOT NULL,
	[UniversalServiceCode] [nvarchar](12) NULL,
	[Department] [nvarchar](3) NULL,
	[DeptProcedureCode] [nvarchar](4) NULL,
	[Description] [nvarchar](100) NOT NULL,
	[Priority] [nvarchar](10) NULL,
	[OrderedOnDT] [smalldatetime] NOT NULL,
	[OrderedForDT] [smalldatetime] NOT NULL,
	[PerformedOnDT] [smalldatetime] NULL,
	[OrderNumber] [nvarchar](20) NULL,
	[OrderSequenceNumber] [nvarchar](15) NULL,
	[Source] [nvarchar](1) NULL,
	[AccessionNumber] [int] NULL,
	[PatientOID] [int] NOT NULL,
	[VisitOID] [int] NOT NULL,
	[ReasonForExam] [nvarchar](100) NULL,
	[Comments] [nvarchar](256) NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.PatientExams already exists, performing Alters (if required)...'

END --ALTERS  
GO  

