---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PatientIdentifiers]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[PatientIdentifiers](
	[IdentifierOID] [int] NOT NULL,
	[IdentifierType] [nvarchar](3) NOT NULL,
	[Entity] [nvarchar](6) NOT NULL,
	[ID] [nvarchar](50) NOT NULL,
	[AssigningSystem] [nvarchar](50) NULL,
	[ExternalID] [nvarchar](50) NULL,
	[CheckDigit] [nchar](1) NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.PatientIdentifiers already exists, performing Alters (if required)...'

END --ALTERS  
GO  

