---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PatientVisits]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[PatientVisits](
	[VisitOID] [int] NOT NULL,
	[Entity] [nvarchar](6) NOT NULL,
	[AdmitDT] [smalldatetime] NULL,
	[DischargeDT] [smalldatetime] NULL,
	[AdmitType] [nvarchar](3) NULL,
	[AdmitClass] [nvarchar](3) NULL,
	[LocationOfService] [nvarchar](50) NULL,
	[NurseStation] [nvarchar](50) NOT NULL,
	[PatientOID] [int] NOT NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.PatientVisits already exists, performing Alters (if required)...'

END --ALTERS  
GO  

