---------------------------------------------------------------------- 
--Whenever adding a column to a table ensure it is added to the CREATE 
--and ALTER sections (for net new vs ported databases) 
---------------------------------------------------------------------- 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Patients]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[Patients](
	[PatientOID] [int] NOT NULL,
	[LastName] [nvarchar](50) NOT NULL,
	[FirstName] [nvarchar](50) NOT NULL,
	[MiddleName] [nvarchar](50) NULL,
	[DateOfBirth] [datetime] NOT NULL,
	[Gender] [nvarchar](1) NULL,
	[Race] [nvarchar](1) NULL,
	[Religion] [nvarchar](50) NULL,
	[Height] [nvarchar](25) NULL,
	[Weight] [nvarchar](25) NULL,
	[IsPregnant] [nchar](1) NULL,
	[LMP] [smalldatetime] NULL,
	[LastExamDT] [smalldatetime] NULL
) ON [PRIMARY]
END

---------------------------------------------------------------------- 
-- Alter Statements begin here 
-- All SQL MUST be rerunnable  
---------------------------------------------------------------------- 
ELSE BEGIN 

     Print 'Table dbo.Patients already exists, performing Alters (if required)...'

END --ALTERS  
GO  

