IF EXISTS (SELECT * FROM sysobjects WHERE type in ('TF','FN','IF') and id = object_id('dbo.fn_GetAlertByStatusAsTable'))
     BEGIN
          DROP FUNCTION dbo.fn_GetAlertByStatusAsTable
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE FUNCTION [fn_GetAlertByStatusAsTable]
(
	-- Add the parameters for the function here
	@in_AlertStatus nvarchar(100),
	@in_ContactID NVARCHAR(200),
	@in_ContactGroupID nvarchar(200) = NULL
)
RETURNS 
@alertTemp TABLE(AlertOID int,ContactOID int)
AS
BEGIN
	-- Fill the table variable with the rows for your result set
IF(@in_ContactGroupID IS NOT NULL)
	BEGIN
	IF EXISTS (SELECT 1 FROM UF_CSVToTable(@in_AlertStatus) WHERE sID = 'Open')
		BEGIN
			INSERT INTO @alertTemp	
								SELECT DISTINCT A.AlertOID, A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
								WHERE  ContactGroupOID IN (@in_ContactGroupID)) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))

								UNION
								SELECT DISTINCT AlertNotificationLog.AlertOID,AlertNotificationLog.ContactOID FROM dbo.AlertNotificationLog
												WHERE AlertNotificationLog.ContactOID IN
											    (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
												WHERE  ContactGroupOID IN (SELECT * FROM UF_CSVToTable(@in_ContactGroupID)))
											EXCEPT
								SELECT DISTINCT A.AlertOID, A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
								WHERE  ContactGroupOID IN (@in_ContactGroupID)) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) NOT IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))
								
								UNION 
								SELECT DISTINCT Alert.AlertOID,Alert.CreatedByContactOID ContactOID FROM dbo.Alert 
												WHERE CreatedByContactOID IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
												WHERE  ContactGroupOID IN (SELECT * FROM UF_CSVToTable(@in_ContactGroupID)))
											EXCEPT
								SELECT DISTINCT A.AlertOID, A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
								WHERE  ContactGroupOID IN (@in_ContactGroupID)) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) NOT IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))
--							
--		 	END		
--		ELSE
--			BEGIN
--							INSERT INTO @alertTemp SELECT AlertOID FROM dbo.Alert WHERE CreatedByContactOID
--							IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
--							WHERE  ContactGroupOID IN (SELECT * FROM UF_CSVToTable(@in_ContactGroupID)))
--					(OLD CODE FROM HERE)	EXCEPT
--								SELECT DISTINCT A.AlertOID, A.ContactOID
--								FROM dbo.AlertResponseLog A
--								INNER JOIN
--								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
--								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
--								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
--								WHERE A.ContactOID IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
--								WHERE  ContactGroupOID IN (@in_ContactGroupID)) GROUP BY A.AlertOID, A.ContactOID
--								HAVING MAX(AlertStatusID) NOT IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
--								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))
--			END
		END
	ELSE
		BEGIN
			INSERT INTO @alertTemp 
				SELECT DISTINCT A.AlertOID,A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID IN (SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
								WHERE  ContactGroupOID IN (@in_ContactGroupID)) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))
		END
	END
ELSE
	BEGIN
			IF EXISTS (SELECT 1 FROM UF_CSVToTable(@in_AlertStatus) WHERE sID = 'Open')
				BEGIN
					INSERT INTO @alertTemp	
							SELECT DISTINCT A.AlertOID, A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID = CAST(@in_ContactID AS INT) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))

								UNION
								SELECT DISTINCT AlertNotificationLog.AlertOID,AlertNotificationLog.ContactOID FROM dbo.AlertNotificationLog
												WHERE AlertNotificationLog.ContactOID = CAST(@in_ContactID AS INT)
											EXCEPT
								SELECT DISTINCT A.AlertOID, A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID = CAST(@in_ContactID AS INT) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) NOT IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))
								
								UNION 
								SELECT DISTINCT Alert.AlertOID,Alert.CreatedByContactOID ContactOID FROM dbo.Alert 
												WHERE CreatedByContactOID = CAST(@in_ContactID AS INT)
											EXCEPT
								SELECT DISTINCT A.AlertOID, A.ContactOID
								FROM dbo.AlertResponseLog A
								INNER JOIN
								(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
								FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
								ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
								WHERE A.ContactOID = CAST(@in_ContactID AS INT) GROUP BY A.AlertOID, A.ContactOID
								HAVING MAX(AlertStatusID) NOT IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
								WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))		
	
--		 			END
--		ELSE
--			BEGIN
--				INSERT INTO @alertTemp 
--					SELECT AlertOID FROM dbo.Alert WHERE CreatedByContactOID = CAST(@in_ContactID AS INT)
			
	
		
		END
	ELSE
		BEGIN
			INSERT INTO @alertTemp 
				SELECT DISTINCT A.AlertOID, A.ContactOID
				FROM dbo.AlertResponseLog A
				INNER JOIN
				(SELECT AlertOID, ContactOID, max(ResponseDateTime) MaxResponseTime
				FROM AlertResponseLog GROUP BY AlertOID, ContactOID) B 
				ON A.AlertOID = B.AlertOID and A.ContactOID = B.ContactOID and A.ResponseDateTime = B.MaxResponseTime
				WHERE A.ContactOID = CAST(@in_ContactID AS INT) GROUP BY A.AlertOID, A.ContactOID
				HAVING MAX(AlertStatusID) IN (SELECT AlertStatus.AlertStatusId FROM dbo.AlertStatus
				WHERE AlertStatus.Name IN(SELECT * FROM UF_CSVToTable(@in_AlertStatus)))
		END
	END
	RETURN 
END
GO
