IF EXISTS (SELECT * FROM sysobjects WHERE type in ('TF','FN','IF') and id = object_id('dbo.fn_GetAlertNotes'))
     BEGIN
          DROP FUNCTION dbo.fn_GetAlertNotes
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Abey Peter>
-- Create date: <03/24/2009>
-- Description:	<Returns the concatenated Notes>
-- =============================================
CREATE FUNCTION [fn_GetAlertNotes] 
(
	-- Add the parameters for the function here
	@alertID INT
)
RETURNS NVARCHAR (4000)
AS
BEGIN
	-- Declare the return variable here
	DECLARE @notes NVARCHAR(4000)
	DECLARE @ntext NVARCHAR(MAX)
	DECLARE @fname NVARCHAR(40)
	DECLARE @mname NVARCHAR(20)
	DECLARE @lname NVARCHAR(40)
	DECLARE @cdate DATETIME
	DECLARE @NumberRecords int, @RowCount int

	SET @notes = ''
	SET @ntext = null
	SET @fname = null
	SET @mname = null
	SET @lname = null
	SET @cdate = null
	DECLARE @tempNOTES TABLE 
		(	 RowID int IDENTITY(1, 1), 
			 NoteText NVARCHAR(MAX),
			 FirstName NVARCHAR(40),
			 MiddleName NVARCHAR(20),
			 LastName NVARCHAR(40),
			 CreateDateTime DATETIME
		)		 	
	-- Add the T-SQL statements to compute the return value here
INSERT INTO	@tempNOTES(NoteText,FirstName,MiddleName,LastName,CreateDateTime) Select N.NoteText,C.FirstName,C.MiddleName,C.LastName ,N.CreateDateTime from dbo.AlertNote N 
,dbo.Contacts C where N.ContactOID = C.ContactOID and N.AlertOID = 198
 
-- Get the number of records in the table variable
SET @NumberRecords = @@ROWCOUNT
SET @RowCount = 1

-- loop through all records in the temporary table
-- using the WHILE loop construct
WHILE @RowCount <= @NumberRecords
BEGIN
 SELECT @ntext = NoteText, @fname = FirstName,@mname = MiddleName, @lname = LastName, @cdate = CreateDateTime
 FROM @tempNOTES
 WHERE RowID = @RowCount
	
SET @notes = @notes + @ntext + ' by '  + @fname + ' ' + @mname + ' ' + @lname + ' ' 
 + ' on ' + cast(@cdate as nvarchar) + char(13)
SET @RowCount = @RowCount + 1

END

	-- Return the result of the function
	RETURN @notes

END
GO
