IF EXISTS (SELECT * FROM sysobjects WHERE type in ('TF','FN','IF') and id = object_id('dbo.fn_GetCurrentPhysicianName'))
     BEGIN
          DROP FUNCTION dbo.fn_GetCurrentPhysicianName
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Abey Peter
-- Create date: 02/19/2009
-- Description:	Returns the Admitting / Attending physician name
-- =============================================
CREATE FUNCTION [fn_GetCurrentPhysicianName]
(
	-- Add the parameters for the function here
	@patientID int,
	@filter nvarchar(15)
)
RETURNS nvarchar(250)
AS
BEGIN
	-- Declare the return variable here
	DECLARE @name nvarchar(250)
	DECLARE @providerId int
		set @name = null
		set @providerId = null
	IF(@filter = 'Admit')
		BEGIN
			select @providerId = ProviderRoleOID from dbo.ProviderRoles where
			[Name] = 'AdmittingPhysician'
		END
	ELSE IF(@filter = 'Attend')
		BEGIN
			select @providerId = ProviderRoleOID from dbo.ProviderRoles where
			[Name] = 'AttendingPhysician'
			
		END
	-- Add the T-SQL statements to compute the return value here
	SELECT @name = ISNULL(C.FirstName, '') + ', ' + ISNULL(C.MiddleName, '') + ', ' + ISNULL(C.LastName, ',') 
	FROM dbo.PatientContacts C ,dbo.ProviderRoles R where C.ProviderRoleOID = @providerId
	and C.PatientOID = @patientID 
	-- Return the result of the function
	RETURN LTRIM(@name)

END
GO
