IF EXISTS (SELECT * FROM sysobjects WHERE type in ('TF','FN','IF') and id = object_id('dbo.fn_GetMRNByPatientID'))
     BEGIN
          DROP FUNCTION dbo.fn_GetMRNByPatientID
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Abey Peter
-- Create date: 02/19/2009
-- Description:	Return the MRN / ADM ID of a patient 
-- =============================================
CREATE FUNCTION [fn_GetMRNByPatientID] 
(
	-- Add the parameters for the function here
	@patientID int,
	@filter char(1)
)
RETURNS nvarchar(255)
AS
BEGIN
	-- Declare the return variable here
	DECLARE @ID nvarchar(255)
	DECLARE @IdentType nvarchar(5)
	SET @ID = null
	SET @IdentType = null

	IF(@filter = 'M')
		BEGIN
			set @IdentType = 'MRN'
		END	
	ELSE IF(@filter = 'A')
		BEGIN
			set @IdentType = 'ADM'
		END
		-- Add the T-SQL statements to compute the return value here
				SELECT @ID = I.ID from dbo.PatientVisits V ,dbo.PatientIdentifiers I	
				where V.Entity = I.Entity and V.PatientOID = I.IdentifierOID and V.PatientOID = @patientID
				and I.IdentifierType = @IdentType
		
	-- Return the result of the function	
RETURN @ID

END
GO
