IF EXISTS (SELECT * FROM sysobjects WHERE type in ('TF','FN','IF') and id = object_id('dbo.fn_GetReferringPhysicianForExam'))
     BEGIN
          DROP FUNCTION dbo.fn_GetReferringPhysicianForExam
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Abey Peter
-- Create date: 02/19/2009
-- Description:	Return ReferringPhysician for Exams
-- =============================================
CREATE FUNCTION [fn_GetReferringPhysicianForExam]
(
	-- Add the parameters for the function here
	@patientID int
)
RETURNS nvarchar(250)
AS
BEGIN
	-- Declare the return variable here
	DECLARE @name nvarchar(100)
	DECLARE @providerId int
	DECLARE @examID int
	set @name = null
	set @providerId = null
	set @examID = null 
	
	if exists(select ExamOID from dbo.PatientExams where PatientOID = @patientID)
		BEGIN
			-- Add the T-SQL statements to compute the return value here
			select @examID = ExamOID from dbo.PatientExams where PatientOID = @patientID 
			select @providerId = P.ProviderRoleOID from dbo.ProviderRoles P where P.Name = 'ReferringPhysician'
			
			SELECT @name = ISNULL(C.FirstName, '') + ',' + ISNULL(C.FirstName, '') + ',' + ISNULL(C.LastName, '') 
			FROM dbo.PatientContacts C ,dbo.ProviderRoles R
			where C.ProviderRoleOID = @providerId
			and C.PatientContactOID = (SELECT PatientContactOID FROM dbo.ExamContactMap WHERE ExamOID = @examID)
		END

	-- Return the result of the function
	RETURN @name

END
GO
