IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_AddressesInsert'))
     BEGIN
          DROP PROCEDURE dbo.hsp_AddressesInsert
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_AddressesInsert]
	@ContactOID int,
	@Ordinal int,
	@AddressOne nvarchar(50),
	@AddressTwo nvarchar(50),
	@City nvarchar(50),
	@State nchar(2),
	@Zip nvarchar(15),
	@PhoneOne nvarchar(10),
	@ExtOne nvarchar(10),
	@PhoneTwo nvarchar(10),
	@ExtTwo nvarchar(10),
	@Mobile nvarchar(10),
	@Pager nvarchar(10),
	@PagerPIN nvarchar(10)
AS
BEGIN
	SET NOCOUNT ON;

	DECLARE @AddressOID int
	EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'Address', @nextOID = @AddressOID OUTPUT

	INSERT INTO [dbo].[Addresses] (
		AddressOID,
		ContactOID,
		Ordinal,
		AddressOne,
		AddressTwo,
		City,
		[State],
		Zip,
		PhoneOne,
		ExtOne,
		PhoneTwo,
		ExtTwo,
		Mobile,
		Pager,
		PagerPIN
	) VALUES (
		@AddressOID,
		@ContactOID,
		@Ordinal,
		@AddressOne,
		@AddressTwo,
		@City,
		@State,
		@Zip,
		@PhoneOne,
		@ExtOne,
		@PhoneTwo,
		@ExtTwo,
		@Mobile,
		@Pager,
		@PagerPIN
	)

	SELECT @AddressOID
END
GO
