IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_CreateLookupValueGroup'))
     BEGIN
          DROP PROCEDURE dbo.hsp_CreateLookupValueGroup
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_CreateLookupValueGroup]
(
  @name         NVARCHAR(50)
, @description  NVARCHAR(255)
, @seqNo        INT           = 0
)
AS
BEGIN

  SET NOCOUNT ON

  DECLARE @lvgOID INT

  IF NOT EXISTS (SELECT 1 FROM LookupValueGroups WHERE [Name] = @name)
  BEGIN

    -- Get the next LookupValueGroupOID to use
    EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'LookupValueGroup', @nextOID = @lvgOID OUTPUT

    INSERT [dbo].[LookupValueGroups]
    (
      [LookupValueGroupOID],
      [Name],
      [Description],
      [SequenceNumber]
	)
    VALUES
    (
      @lvgOID,
      @name,
      @description,
      @seqNo
    )
  END
  ELSE
  BEGIN
    -- LookupValueGroup already exists
    RAISERROR (N'LookupValueGroup %s already exists, NOT able to add.'
              ,0 -- Severity
              ,1 -- State
              ,@name);
  END
END
GO
