IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_DeleteAlert'))
     BEGIN
          DROP PROCEDURE dbo.hsp_DeleteAlert
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--region [dbo].[hsp_InsertUpdateAlert]

------------------------------------------------------------------------------------------------------------------------
-- Generated By:   mmerritt using CodeSmith 5.0.0.0
-- Template:       StoredProcedures.cst
-- Procedure Name: [dbo].[hsp_InsertUpdateAlert]
-- Date Generated: Saturday, February 07, 2009
------------------------------------------------------------------------------------------------------------------------

/*
sample usage : 

DECLARE
	@AlertOID INT,
	@NotificationKey nvarchar(50),
	@AlertTypeOID INT,
	@AlertClassOID INT,
	@SeverityLevelOID INT,
	@SeverityLevelSnapshot nvarchar(100),
	@AlertDateTime datetime,
	@AlertDateTimeGMTOffset int,
	@CriteriaSnapshot nvarchar(255),
	@CreatedByContactOID INT

 SET @AlertOID = ''
 SET @NotificationKey = ''
 SET @AlertTypeOID = ''
 SET @AlertClassOID = ''
 SET @SeverityLevelOID = ''
 SET @SeverityLevelSnapshot = ''
 SET @AlertDateTime = ''
 SET @AlertDateTimeGMTOffset = ''
 SET @CriteriaSnapshot = ''
 SET @CreatedByContactOID = ''

EXEC [dbo].[hsp_InsertUpdateAlert] @AlertOID, @NotificationKey, @AlertTypeOID, @AlertClassOID, @SeverityLevelOID, @SeverityLevelSnapshot, @AlertDateTime, @AlertDateTimeGMTOffset, @CriteriaSnapshot, @CreatedByContactOID

*/


--region [dbo].[hsp_DeleteAlert]

------------------------------------------------------------------------------------------------------------------------
-- Generated By:   mmerritt using CodeSmith 5.0.0.0
-- Template:       StoredProcedures.cst
-- Procedure Name: [dbo].[hsp_DeleteAlert]
-- Date Generated: Saturday, February 07, 2009
------------------------------------------------------------------------------------------------------------------------

CREATE PROCEDURE [hsp_DeleteAlert]
	@AlertOID INT
AS

SET NOCOUNT ON

BEGIN TRANSACTION

SET NOCOUNT ON

DELETE FROM [dbo].[AlertNote]
WHERE [AlertOID] = @AlertOID

DELETE FROM [dbo].[AlertNotificationLog]
WHERE [AlertOID] = @AlertOID

DELETE FROM [dbo].[AlertResponseLog]
WHERE [AlertOID] = @AlertOID

DELETE FROM [dbo].[Alert]
WHERE [AlertOID] = @AlertOID

DELETE FROM [dbo].[AlertException]
WHERE [AlertOID] = @AlertOID

COMMIT TRANSACTION

--endregion
GO
