IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_DropTableForeignKeys'))
     BEGIN
          DROP PROCEDURE dbo.hsp_DropTableForeignKeys
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_DropTableForeignKeys]
(
  @tableName SYSNAME
)
AS
BEGIN
  DECLARE @keyName SYSNAME
  DECLARE @tableOID INT

  SELECT @tableOID = OBJECT_ID(@tableName)

  IF EXISTS (SELECT 1 FROM [sys].[objects] WHERE object_id = @tableOID AND type = 'U')
  BEGIN

    -- If the table has any FOREIGN KEY CONSTRAINT(s) loop through each and drop
    IF EXISTS (SELECT 1 FROM [sys].[objects] WHERE parent_object_id = @tableOID AND type = 'F')
    BEGIN

      DECLARE
        Table_FKeys
      CURSOR FOR
      SELECT
        name
      FROM
        [sys].[objects]
      WHERE
        parent_object_id = @tableOID
        AND type = 'F'

      OPEN Table_FKeys
      FETCH NEXT FROM Table_FKeys INTO @keyName

      WHILE @@FETCH_STATUS = 0
      BEGIN
        PRINT 'Dropping existing index ' + @keyName + ' on ' + @tableName
        EXEC('ALTER TABLE ' + @tableName + ' DROP CONSTRAINT ' + @keyName)

        FETCH NEXT FROM Table_FKeys INTO @keyName
      END
 
      CLOSE Table_FKeys
      DEALLOCATE Table_FKeys
    END
  END
END
GO
