IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_GetAlertsByFilter'))
     BEGIN
          DROP PROCEDURE dbo.hsp_GetAlertsByFilter
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Abey Peter>
-- Create date: <03/16/2009>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [hsp_GetAlertsByFilter]
	-- Add the parameters for the stored procedure here
	@in_AlertStatus nvarchar(100) = null,
	@in_Descripition nvarchar(100) = NULL,
	@in_Levels nvarchar(100) = NULL,
	@in_ResultStatus nvarchar(5) = NULL,
	@in_sResp nvarchar(50) = NULL,
	@in_eResp nvarchar(50) = NULL,
	@in_ContactGroupID nvarchar(200) = NULL,
	@in_Receipt nvarchar(15) = NULL,
	@in_Exceptional bit = NULL,
	@in_ContactID INT,
	@in_Admin bit
	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	SET TRANSACTION ISOLATION LEVEL READ COMMITTED

	DECLARE @alertSql nvarchar(4000)
	DECLARE @tempContactGroupID nvarchar(10)
	create table #tempAlerts ([AlertOID] [int] NULL,
	[AlertLevelOID] [int] NULL,
	[CreatedByContactOID] [int] NULL,
	[Notes] [nvarchar] (4000) NULL,
	[ExamDescription] [nvarchar] (100) NULL,
	[AlertStatus] [nvarchar] (15) NULL,
	[LastEscalation] [datetime] NULL,
	[NextEscalation] [datetime] NULL,
	[PatientOID] [int] NULL,
	[PatientResultOID] [INT] NULL,
	[FirstName] [nvarchar](50) NULL,
	[MiddleName] [nvarchar](50) NULL,
	[LastName] [nvarchar](50) NULL,
	[MRN] [nvarchar](50) NULL,
	[DateOfBirth] [datetime] NULL,
	[AdmitClass] [nvarchar](3) NULL,
	[AdmittingPhysician] [nvarchar](100) NULL,
	[AttendingPhysician] [nvarchar](100) NULL,
	[Location] [nvarchar](50) NULL,
	[AccountNumber] [nvarchar](50) NULL,
	[Gender] [nvarchar](1) NULL,
	[AdmitType] [nvarchar](3) NULL,
	[Height] [nvarchar](25) NULL,
	[Weight] [nvarchar](25) NULL,
	[IsPregnant] [nchar](1) NULL,
	[LMP] [smalldatetime] NULL,
	[VisitOID] [int] null)

    -- Insert statements for procedure here
	SET @alertSql = 'INSERT INTO #tempAlerts select distinct A.AlertOID,A.AlertLevelOID,A.CreatedByContactOID,
	dbo.fn_GetAlertNotes(A.AlertOID)Notes,
(select E.Description from dbo.PatientExams E,dbo.ExamAlertDataMap M
where E.ExamOID = M.ExamOID and M.AlertDataOID = A.AlertOID)ExamDescription,
dbo.fn_GetAlertStatus(A.AlertOID,' +cast(@in_ContactID as nvarchar(50)) + ') AS AlertStatus,
A.LastEscalation,A.NextEscalation,
		P.PatientOID,
		A.PatientResultOID,
		P.FirstName,
		P.MiddleName,
		P.LastName,
		dbo.fn_GetMRNByPatientID(P.PatientOID,''M'') AS MRN,
		P.DateOfBirth,
		V.AdmitClass,
		dbo.fn_GetCurrentPhysicianName(P.PatientOID,''Admit'') AS AdmittingPhysician,
		dbo.fn_GetCurrentPhysicianName(P.PatientOID,''Attend'') AS AttendingPhysician,
		V.NurseStation AS Location,
		dbo.fn_GetMRNByPatientID(P.PatientOID,''A'') AS AccountNumber,
		P.Gender,
		V.AdmitType,P.Height,P.Weight,P.IsPregnant,P.LMP,V.VisitOID from dbo.Patients P
		left join(select A.* from PatientVisits A Inner join
		(select PatientOID, max(isnull (AdmitDT,''01/01/1900'')) Maxadmitdate from PatientVisits
		group by PatientOID) B
		On A.PatientOID = B.PatientOID and A.AdmitDT = B.Maxadmitdate
		) V
		on P.PatientOID = V.PatientOID inner join
        dbo.Alert A On P.PatientOID = A.PatientOID '

	IF(@in_Descripition is not null)
		BEGIN
			SET @alertSql = @alertSql + ' INNER JOIN (select E.ExamOID,M.AlertDataOID from dbo.PatientExams E ,dbo.ExamAlertDataMap M
										 where E.ExamOID = M.ExamOID and E.Description LIKE ' + quotename(@in_Descripition + '%','''')
										+ ') PE on A.AlertOID = PE.AlertDataOID '	
		END 
	IF (@in_AlertStatus IS NOT NULL)
		BEGIN
			--SET @alertSql = @alertSql + ' INNER JOIN (SELECT * FROM dbo.fn_GetAlertByStatusAsTable('+quotename(@in_AlertStatus,'''') + ',' + quotename(@in_ContactID,'''') + ')) ST ON A.AlertOID = ST.AlertOID '
			IF((@in_ContactGroupID IS NOT NULL) AND (@in_ContactGroupID != '')) 
				BEGIN
					SET @alertSql = @alertSql + ' INNER JOIN (SELECT * FROM dbo.fn_GetAlertByStatusAsTable('+ quotename(@in_AlertStatus,'''') + ',' + quotename(@in_ContactID,'''') + ',' + quotename(@in_ContactGroupID,'''') +')) ST ON A.AlertOID = ST.AlertOID '
				END
			ELSE IF(@in_ContactGroupID = '')
				BEGIN
					SET @alertSql = @alertSql + ' INNER JOIN (SELECT * FROM dbo.fn_GetAlertByStatusAsTable('+ quotename(@in_AlertStatus,'''') + ',' + quotename(@in_ContactID,'''') + ',NULL)) ST ON A.AlertOID = ST.AlertOID '
				END 
			ELSE IF(@in_ContactGroupID IS NULL)
				BEGIN
					IF(@in_Admin = 0)
						BEGIN
							SELECT @tempContactGroupID = ContactGroupOID FROM dbo.ContactContactGroupMap
							WHERE ContactOID = @in_ContactID
							SET @alertSql = @alertSql + ' INNER JOIN (SELECT * FROM dbo.fn_GetAlertByStatusAsTable('+ quotename(@in_AlertStatus,'''') + ',' + quotename(@in_ContactID,'''') + ',' + quotename(@tempContactGroupID,'''') +')) ST ON A.AlertOID = ST.AlertOID '
						END
					ELSE
						BEGIN
							SET @alertSql = @alertSql + ' INNER JOIN (SELECT * FROM dbo.fn_GetAlertByStatusForAdmin('+ quotename(@in_AlertStatus,'''') + ')) ST ON A.AlertOID = ST.AlertOID '
						END
				END
		END
	IF(@in_ResultStatus IS NOT NULL)
		BEGIN
			SET @alertSql = @alertSql + ' INNER JOIN (SELECT R.* FROM dbo.PatientResults R WHERE R.ResultStatus IN (SELECT * FROM UF_CSVToTable(' +quotename(@in_ResultStatus,'''') + '))) RS
										 ON A.PatientResultOID = RS.PatientResultOID '
		END
	IF(@in_sResp IS NOT NULL)
		BEGIN
			SET @alertSql = @alertSql + ' INNER JOIN ( SELECT AlertResponseLog.AlertOID FROM dbo.AlertResponseLog WHERE AlertResponseLog.ResponseDateTime 
										BETWEEN ' + quotename(@in_sResp,'''') + ' AND ' + quotename(@in_eResp,'''')
										+ ')LR  ON A.AlertOID = LR.AlertOID '
		END
	IF (@in_Exceptional IS NOT NULL)
			BEGIN
				IF(@in_Exceptional = 1)
					begin
						SET @alertSql = @alertSql + ' inner join  (select distinct AlertOID from dbo.AlertException where ResolvedDT is null) AE 
							on AE.AlertOID = A.AlertOID'
						
					end
				else
					begin
						SET @alertSql = @alertSql + ' inner join  (select distinct AlertOID from dbo.AlertException where ResolvedDT is not null) AE 
							on AE.AlertOID = A.AlertOID'
					end
			END	
	
	IF((@in_ContactGroupID IS NOT NULL) AND (@in_ContactGroupID != '')) 
			BEGIN
				IF(@in_Receipt IS NULL)
					BEGIN
							SET @alertSql = @alertSql + ' INNER JOIN 
							(SELECT A.AlertOID,A.ContactOID FROM(select Alert.AlertOID, Alert.CreatedByContactOID ContactOID FROM dbo.Alert UNION 
					SELECT AlertNotificationLog.AlertOID,AlertNotificationLog.ContactOID FROM 
					dbo.AlertNotificationLog UNION SELECT AlertResponseLog.AlertOID,AlertResponseLog.ContactOID FROM dbo.AlertResponseLog) A INNER JOIN (
					SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
					WHERE  ContactGroupOID IN (SELECT * FROM UF_CSVToTable(' + quotename(@in_ContactGroupID,'''') + '))) B 
					on A.ContactOID = B.ContactOID) CG ON A.AlertOID = CG.AlertOID '
					END
				ELSE IF(@in_Receipt = 'Sent')
					BEGIN
						
						SET @alertSql = @alertSql + 'INNER JOIN ( SELECT Alert.AlertOID FROM dbo.Alert INNER JOIN
						ContactContactGroupMap ON ContactContactGroupMap.ContactOID	= Alert.CreatedByContactOID WHERE 				
						ContactContactGroupMap.ContactGroupOID IN (SELECT * FROM UF_CSVToTable(' + quotename(@in_ContactGroupID,'''') + '))) CGS ON A.AlertOID = CGS.AlertOID '
					END
				ELSE IF(@in_Receipt = 'Received')
					BEGIN
						SET @alertSql = @alertSql + 'INNER JOIN ( SELECT AlertNotificationLog.AlertOID FROM dbo.AlertNotificationLog INNER JOIN
						ContactContactGroupMap ON ContactContactGroupMap.ContactOID	= AlertNotificationLog.ContactOID WHERE 				
						ContactContactGroupMap.ContactGroupOID IN (SELECT * FROM UF_CSVToTable(' + quotename(@in_ContactGroupID,'''') + '))) CGR ON A.AlertOID = CGR.AlertOID '
					END
			END
	ELSE IF(@in_ContactGroupID = '')
			BEGIN
				IF(@in_Receipt IS NULL)
					BEGIN
							SET @alertSql = @alertSql + ' INNER JOIN 
							(select Alert.AlertOID FROM dbo.Alert WHERE Alert.CreatedByContactOID = ' + cast(@in_ContactID as nvarchar(20)) + '
							UNION SELECT AlertNotificationLog.AlertOID FROM dbo.AlertNotificationLog
							WHERE AlertNotificationLog.ContactOID = ' + cast(@in_ContactID as nvarchar(20)) + '
							UNION SELECT AlertResponseLog.AlertOID FROM dbo.AlertResponseLog
							WHERE AlertResponseLog.ContactOID = ' + cast(@in_ContactID as nvarchar(20)) + '
							)CG ON A.AlertOID = CG.AlertOID'
					END
				ELSE IF(@in_Receipt = 'Sent')
					BEGIN
						SET @alertSql = @alertSql + ' INNER JOIN 
							(select Alert.AlertOID FROM dbo.Alert WHERE Alert.CreatedByContactOID = ' + cast(@in_ContactID as nvarchar(20)) + ') CGS ON A.AlertOID = CGS.AlertOID '
					END	
				ELSE IF(@in_Receipt = 'Received')
					BEGIN
						SET @alertSql = @alertSql + ' INNER JOIN (SELECT AlertNotificationLog.AlertOID FROM dbo.AlertNotificationLog
							WHERE AlertNotificationLog.ContactOID = ' + cast(@in_ContactID as nvarchar(20)) + ')CGR ON A.AlertOID = CGR.AlertOID '
					END
			END	
		ELSE IF(@in_ContactGroupID IS NULL)
			BEGIN
				IF(@in_Admin = 0)
					BEGIN
						IF(@in_Receipt IS NULL)
							BEGIN
												SET @alertSql = @alertSql + 'INNER JOIN 
									(select A.AlertOID,A.ContactOID FROM(select Alert.AlertOID, Alert.CreatedByContactOID ContactOID FROM dbo.Alert UNION 
							SELECT AlertNotificationLog.AlertOID,AlertNotificationLog.ContactOID FROM 
							dbo.AlertNotificationLog UNION SELECT AlertResponseLog.AlertOID,AlertResponseLog.ContactOID FROM dbo.AlertResponseLog) A INNER JOIN (
							SELECT DISTINCT ContactContactGroupMap.ContactOID FROM dbo.ContactContactGroupMap 
							WHERE  ContactGroupOID IN (SELECT DISTINCT ContactGroupOID FROM dbo.ContactContactGroupMap WHERE ContactOID = ' + cast(@in_ContactID as nvarchar(20)) + ')) B 
							on A.ContactOID = B.ContactOID) CG ON A.AlertOID = CG.AlertOID '
							END
						ELSE IF(@in_Receipt = 'Sent')
							BEGIN
								SET @alertSql = @alertSql + 'INNER JOIN ( SELECT Alert.AlertOID FROM dbo.Alert INNER JOIN
								ContactContactGroupMap ON ContactContactGroupMap.ContactOID	= Alert.CreatedByContactOID WHERE 				
								ContactContactGroupMap.ContactGroupOID IN (SELECT DISTINCT ContactGroupOID FROM dbo.ContactContactGroupMap WHERE ContactOID = ' + cast(@in_ContactID as nvarchar(20)) + ')) CGS ON A.AlertOID = CGS.AlertOID '
							END
						ELSE IF(@in_Receipt = 'Received')
							BEGIN
								SET @alertSql = @alertSql + 'INNER JOIN ( SELECT AlertNotificationLog.AlertOID FROM dbo.AlertNotificationLog INNER JOIN
								ContactContactGroupMap ON ContactContactGroupMap.ContactOID	= AlertNotificationLog.ContactOID WHERE 				
								ContactContactGroupMap.ContactGroupOID IN (SELECT DISTINCT ContactGroupOID FROM dbo.ContactContactGroupMap WHERE ContactOID = ' + cast(@in_ContactID as nvarchar(20)) + ')) CGR ON A.AlertOID = CGR.AlertOID '
							END
					END
						
			END
			
	
	IF (@in_Levels IS NOT NULL)
			BEGIN
				SET @alertSql = @alertSql + ' WHERE A.AlertLevelOID IN (SELECT * FROM UF_CSVToTable(' + quotename(@in_Levels,'''') + '))'
			END 
	

print @alertSql

 EXEC sp_executesql @alertSql

select * from #tempAlerts

SELECT 
A.AlertOID,PatientResults.PatientOID, PatientResults.PatientResultOID, PatientResults.ResultStatus, PatientResults.ResultText 
FROM PatientResults ,dbo.#tempAlerts A where PatientResults.PatientResultOID = A.PatientResultOID
 
UNION ALL

SELECT 
A.AlertOID,PatientResults.PatientOID, PatientResults.PatientResultOID, PatientResults.ResultStatus, PatientResults.ResultText 
FROM 
	(
	select A.*, B.PatientResultOID B_ResultOID
	from PatientResults A
	Inner Join (select PatientResultOID,PreviousResultOID from PatientResults where PreviousResultOID is not null) B
	On A.PatientResultOID = B.PreviousResultOID 
	) PatientResults ,dbo.#tempAlerts A where PatientResults.B_ResultOID = A.PatientResultOID

SELECT A.ExceptionOID,A.AlertOID,A.ExceptionDT,A.Reason AlertExceptionType,A.ContactOID,A.ResolvedDT
FROM dbo.AlertException A,dbo.#tempAlerts T WHERE T.AlertOID = A.AlertOID

SELECT TA.AlertOID,N.ContactOID,C.FirstName,C.MiddleName,C.LastName,
dbo.fn_GetAlertStatus(TA.AlertOID,N.ContactOID) AlertStatus,(SELECT MAX(AlertResponseLog.ResponseDateTime) FROM 
dbo.AlertResponseLog WHERE AlertResponseLog.AlertOID = TA.AlertOID AND 
AlertResponseLog.ContactOID = N.ContactOID) LastUpdate FROM dbo.#tempAlerts TA,dbo.AlertNotificationLog N,
dbo.Contacts C WHERE TA.AlertOID = N.AlertOID AND N.ContactOID = C.ContactOID

drop table #tempAlerts

END
GO
