IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_GetContactsByFilter'))
     BEGIN
          DROP PROCEDURE dbo.hsp_GetContactsByFilter
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Abey Peter
-- Create date: 03/10/2009
-- Description:	Returns the contact details 
-- =============================================
CREATE PROCEDURE [hsp_GetContactsByFilter]
	-- Add the parameters for the stored procedure here
	@in_cStatus char(1) = null,
	@in_cPatient nvarchar(50) = NULL,
	@in_cExam nvarchar(50) = NULL
	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	SET TRANSACTION ISOLATION LEVEL READ COMMITTED

DECLARE @contactSql nvarchar(4000)

create table #tempContacts ([ContactOID] [int] NULL,
	[Status] [char](1) NULL,
	[ExternalID][nvarchar](50) NULL,
	[FirstName] [nvarchar] (40) NULL,
	[MiddleName] [nvarchar](50) NULL,
	[LastName] [nvarchar](50) NULL,
	[Prefix] [nvarchar](10) NULL,
	[Suffix] [nvarchar](10) NULL,
	[Title] [nvarchar](20) NULL,
	[DrTitle] [nvarchar](20) NULL,
	[UserId] [int] NULL,
	[UserName] [nvarchar](256) NULL,
	[Role] [varchar] (200) NULL)


    -- Insert statements for procedure here
	SET @contactSql = 'INSERT INTO #tempContacts SELECT C.ContactOID,C.Status,C.ExternalID,C.FirstName,C.MiddleName,C.LastName,C.Prefix,C.Suffix,C.Title,
		C.DrTitle,P.UserOID,P.UserName,
		STUFF(
		(SELECT ' +''',''' + ' + CONVERT(varchar, SystemRoles.[SystemRoleOID]) FROM dbo.SystemRoles
		INNER JOIN dbo.SystemRoleUserMap ON SystemRoleUserMap.SystemRoleOID = SystemRoles.SystemRoleOID 
		WHERE dbo.SystemRoleUserMap.UserOID = C.UserOID 
		FOR XML PATH (' +'''''' + ')),1,1,' +'''''' +') AS Roles FROM dbo.Contacts C LEFT JOIN 
		(SELECT * FROM dbo.Users) P ON C.UserOID = P.UserOId ' 
	IF(@in_cPatient IS NOT NULL)
		BEGIN
			SET @contactSql = @contactSql + ' INNER JOIN (SELECT ContactOID FROM dbo.PatientContacts 
												WHERE PatientOID = ' + quotename(@in_cPatient,'''')  + ') PC ON 
											C.ContactOID = PC.ContactOID '
		END
	IF(@in_cExam IS NOT NULL)
		BEGIN
			SET @contactSql = @contactSql + ' INNER JOIN (SELECT PatientContacts.ContactOID FROM dbo.PatientContacts
											INNER JOIN dbo.ExamContactMap ON PatientContacts.PatientContactOID = ExamContactMap.PatientContactOID WHERE ExamContactMap.ExamOID = ' +quotename(@in_cExam,'''') + ') EC 
											ON C.ContactOID = EC.ContactOID ' 
		END
	IF(@in_cStatus IS NOT NULL)
		BEGIN
			SET @contactSql = @contactSql + ' where C.Status = ' + quotename(@in_cStatus,'''')
		END


exec sp_executesql @contactSql
select * from #tempContacts

select A.AddressOID,A.ContactOID,A.AddressOne,A.AddressTwo,A.City,A.State,A.Zip,
A.PhoneOne,A.ExtOne,A.PhoneTwo,A.ExtTwo,A.Mobile,A.Pager,A.PagerPIN
from dbo.Addresses A, #tempContacts C where A.ContactOID = C.ContactOID

SELECT DISTINCT C.ContactProfileOID,T.ContactOID,dbo.fn_GetPrimaryCommMethods(C.ContactProfileOID,'P')PrimaryMethod,dbo.fn_GetPrimaryCommMethods(C.ContactProfileOID,'B')BackupMethod
FROM dbo.CommMethodContactProfileMap P,dbo.ContactProfiles C,#tempContacts T WHERE P.ContactProfileOID = C.ContactProfileOID
AND T.ContactOID = C.ContactOID ORDER BY C.ContactProfileOID

SELECT C.CommMethodOID,C.ContactOID,TP.Name,C.Description,C.Value FROM dbo.CommMethods C ,#tempContacts TC ,dbo.CommTypes TP
WHERE C.ContactOID = TC.ContactOID AND C.CommTypeOID = TP.CommTypeOID

Drop table #tempContacts



END
GO
