IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_GetNextOID_ByOutputVar'))
     BEGIN
          DROP PROCEDURE dbo.hsp_GetNextOID_ByOutputVar
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_GetNextOID_ByOutputVar]
(
  @oidDescriptor NVARCHAR(50)
, @nextOID       INT OUTPUT
, @incrementBy   INT = 1
)
AS
BEGIN

  -- Make sure a valid increment value was passed
  IF (@incrementBy < 1)
  BEGIN
    SELECT @incrementBy = 1
  END

  -- Initialize the return value
  SELECT @nextOID = 0

  -- Update the NextOID table within the scope of a transaction
  BEGIN TRAN

  UPDATE
    NextOID
  SET
    LastOIDUsed = LastOIDUsed + @incrementBy 
  WHERE
    Descriptor = @oidDescriptor

  IF (@@ROWCOUNT = 0)
  BEGIN
    INSERT NextOID (Descriptor, LastOIDUsed) VALUES (@oidDescriptor, @incrementBy)
  END

  COMMIT TRAN

  SELECT
    @nextOID = LastOIDUsed - @incrementBy + 1
  FROM
    NextOID
  WHERE
    Descriptor = @oidDescriptor

END
GO
