IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertAlertWorkList'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertAlertWorkList
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Abey George>
-- Create date: <03/26/2009>
-- Updated date : <03/27/2009>
-- Description:	<Insert & Update AlertWorkList>
-- =============================================
CREATE PROCEDURE [hsp_InsertAlertWorkList]
	-- Add the parameters for the stored procedure here
		   @in_WrkListID INT = NULL,  
		   @in_ContactOID int = null,
           @in_Name nvarchar(50) = null,
           @in_Filter nvarchar(4000) = null,
           @in_ColAlertStatus int = null,
           @in_ColLastResponse int = null,
           @in_ColEscalationLevel int = null,
           @in_ColLastEscalation int = null,
           @in_ColNextEscalation int = null,
           @in_ColExam int = null,
           @in_ColResultStatus int = null,
           @in_ColPatientName int = null,
           @in_ColMRN int = null,
           @in_ColAccount int = null,
           @in_ColAdmitting int = null,
           @in_ColAttending int = null,
           @in_ColAdmitType int = null,
           @in_ColAdmitClass int = null,
           @in_ColLocation int = null,
           @in_ColLastUpdate int = null,
           @in_ColDateOfBirth int = null,
           @in_ColAge int = null,
           @in_ColHeight int = null,
           @in_ColWeight int = null,
           @in_ColGender int = null,
           @in_ColPregnant int = null,
           @in_ColLMP int = null,
		   @AlertWorklistOID INT OUTPUT	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
IF(@in_WrkListID IS NULL)
	BEGIN
			EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'AlertWorklists', @nextOID = @AlertWorklistOID OUTPUT
			-- Insert statements for procedure here
			INSERT INTO [Notifi-working].[dbo].[AlertWorklists]
				   ([AlertWorklistOID]
				   ,[ContactOID]
				   ,[Name]
				   ,[Filter]
				   ,[ColAlertStatus]
				   ,[ColLastResponse]
				   ,[ColEscalationLevel]
				   ,[ColLastEscalation]
				   ,[ColNextEscalation]
				   ,[ColExam]
				   ,[ColResultStatus]
				   ,[ColPatientName]
				   ,[ColMRN]
				   ,[ColAccount]
				   ,[ColAdmitting]
				   ,[ColAttending]
				   ,[ColAdmitType]
				   ,[ColAdmitClass]
				   ,[ColLocation]
				   ,[ColLastUpdate]
				   ,[ColDateOfBirth]
				   ,[ColAge]
				   ,[ColHeight]
				   ,[ColWeight]
				   ,[ColGender]
				   ,[ColPregnant]
				   ,[ColLMP])
			 VALUES
				   (@AlertWorklistOID,
					@in_ContactOID,
				   @in_Name,
				   @in_Filter,
				   @in_ColAlertStatus,
				   @in_ColLastResponse,
				   @in_ColEscalationLevel,
				   @in_ColLastEscalation,
				   @in_ColNextEscalation,
				   @in_ColExam,
				   @in_ColResultStatus,
				   @in_ColPatientName,
				   @in_ColMRN,
				   @in_ColAccount,
				   @in_ColAdmitting,
				   @in_ColAttending,
				   @in_ColAdmitType,
				   @in_ColAdmitClass,
				   @in_ColLocation,
				   @in_ColLastUpdate,
				   @in_ColDateOfBirth,
				   @in_ColAge,
				   @in_ColHeight,
				   @in_ColWeight,
				   @in_ColGender,
				   @in_ColPregnant,
				   @in_ColLMP
					)
		END
ELSE IF EXISTS (SELECT 1 FROM dbo.AlertWorklists WHERE AlertWorklistOID = @in_WrkListID)
	BEGIN
				UPDATE [Notifi-working].[dbo].[AlertWorklists]
		   SET 
			   [ContactOID] = @in_ContactOID
			  ,[Name] = @in_Name
			  ,[Filter] = @in_Filter
			  ,[ColAlertStatus] = @in_ColAlertStatus
			  ,[ColLastResponse] = @in_ColLastResponse
			  ,[ColEscalationLevel] = @in_ColEscalationLevel
			  ,[ColLastEscalation] = @in_ColLastEscalation
			  ,[ColNextEscalation] = @in_ColNextEscalation
			  ,[ColExam] = @in_ColExam
			  ,[ColResultStatus] = @in_ColResultStatus
			  ,[ColPatientName] = @in_ColPatientName
			  ,[ColMRN] = @in_ColMRN
			  ,[ColAccount] = @in_ColAccount
			  ,[ColAdmitting] = @in_ColAdmitting
			  ,[ColAttending] = @in_ColAttending
			  ,[ColAdmitType] = @in_ColAdmitType
			  ,[ColAdmitClass] = @in_ColAdmitClass
			  ,[ColLocation] = @in_ColLocation
			  ,[ColLastUpdate] = @in_ColLastUpdate
			  ,[ColDateOfBirth] = @in_ColDateOfBirth
			  ,[ColAge] = @in_ColAge
			  ,[ColHeight] = @in_ColHeight
			  ,[ColWeight] = @in_ColWeight
			  ,[ColGender] = @in_ColGender
			  ,[ColPregnant] = @in_ColPregnant
			  ,[ColLMP] = @in_ColLMP
		 WHERE AlertWorklistOID = @in_WrkListID
	END
ELSE
	BEGIN
		RAISERROR('AlertWorklistOID doesnt exist',16,1)
	END
END
GO
