IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertContact'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertContact
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InsertContact]
	@Status char(1),
	@UserOID INT,
	@ExternalID nvarchar(50),
	@FirstName nvarchar(40),
	@MiddleName nvarchar(20),
	@LastName nvarchar(40),
	@Prefix nvarchar(10),
	@Suffix nvarchar(10),
	@Title nvarchar(20),
	@DrTitle nvarchar(10),	
	@CanViewVIP bit,
	@DoesTimeout bit,
	@ContactOID INT output

AS

EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'Contact', @nextOID = @ContactOID OUTPUT

INSERT INTO dbo.Contacts (ContactOID, [Status], UserOID, ExternalID, FirstName, MiddleName, LastName, Prefix, Suffix, Title, DrTitle, CanViewVIP, DoesTimeout)
VALUES (@ContactOID, @Status, @UserOID, @ExternalID, @FirstName, @MiddleName, @LastName, @Prefix, @Suffix, @Title, @DrTitle, @CanViewVIP, @DoesTimeout)
GO
