IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertPatient'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertPatient
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InsertPatient]
	@LastName nvarchar(50),
	@FirstName nvarchar(50),
	@MiddleName nvarchar(50),
	@DateOfBirth datetime,
	@Gender nchar(1),
	@Race nchar(1),
	@Religion nvarchar(50),
	@Height nvarchar(25),
	@Weight nvarchar(25),
	@IsPregnant nchar(1),
	@LMP smalldatetime,
	@LastExamDT smalldatetime,
	@PatientOID INT output

AS

EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'Patient', @nextOID = @PatientOID OUTPUT

INSERT INTO dbo.Patients (PatientOID, LastName, FirstName, MiddleName, DateOfBirth, Gender, Race, Religion, Height, Weight, IsPregnant, LMP, LastExamDT)
VALUES (@PatientOID, @LastName, @FirstName, @MiddleName, @DateOfBirth, @Gender, @Race, @Religion, @Height, @Weight, @IsPregnant, @LMP, @LastExamDT)
GO
