IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertPatientWorkList'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertPatientWorkList
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Abey George
-- Create date: 03/26/2009
-- Updated Date: 03/27/2009
-- Description:	Insert & Update PatientWorkList
-- =============================================
CREATE PROCEDURE [hsp_InsertPatientWorkList] 
	-- Add the parameters for the stored procedure here
		   @in_WrkListID INT = NULL,
		   @in_ContactOID  INT = null,
           @in_Name nvarchar(50) = null,
           @in_Filter nvarchar(4000) = null,
           @in_ColPatientName  INT = null,
           @in_ColMRN  INT = null,
           @in_ColAccount  INT = null,
           @in_ColAdmitting  INT = null,
           @in_ColAttending  INT = null,
           @in_ColAdmitType  INT = null,
           @in_ColAdmitClass  INT = null,
           @in_ColLocation  INT = null,
           @in_ColLastUpdate  INT = null,
           @in_ColDateOfBirth  INT = null,
           @in_ColAge  INT = null,
           @in_ColHeight  INT = null,
           @in_ColWeight  INT = null,
           @in_ColGender  INT = null,
           @in_ColPregnant  INT = null,
           @in_ColLMP  INT = null,
		   @PatientWorklistOID  INT = null OUTPUT 	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	--  INTerfering with SELECT statements.
	SET NOCOUNT ON;
IF(@in_WrkListID IS NULL)
	BEGIN

			EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'PatientWorklists', @nextOID = @PatientWorklistOID OUTPUT

		   INSERT  INTO [Notifi-working].[dbo].[PatientWorklists]
				   ([PatientWorklistOID]
				   ,[ContactOID]
				   ,[Name]
				   ,[Filter]
				   ,[ColPatientName]
				   ,[ColMRN]
				   ,[ColAccount]
				   ,[ColAdmitting]
				   ,[ColAttending]
				   ,[ColAdmitType]
				   ,[ColAdmitClass]
				   ,[ColLocation]
				   ,[ColLastUpdate]
				   ,[ColDateOfBirth]
				   ,[ColAge]
				   ,[ColHeight]
				   ,[ColWeight]
				   ,[ColGender]
				   ,[ColPregnant]
				   ,[ColLMP])
			 VALUES
				   (@PatientWorklistOID,
					@in_ContactOID,
				   @in_Name,
				   @in_Filter,
				   @in_ColPatientName,
				   @in_ColMRN,
				   @in_ColAccount,
				   @in_ColAdmitting,
				   @in_ColAttending,
				   @in_ColAdmitType,
				   @in_ColAdmitClass,
				   @in_ColLocation,
				   @in_ColLastUpdate,
				   @in_ColDateOfBirth,
				   @in_ColAge,
				   @in_ColHeight,
				   @in_ColWeight,
				   @in_ColGender,
				   @in_ColPregnant,
				   @in_ColLMP)
	END
	
ELSE IF EXISTS (SELECT 1 FROM dbo.PatientWorklists WHERE PatientWorklistOID = @in_WrkListID)
	BEGIN
		UPDATE [Notifi-working].[dbo].[PatientWorklists]
   SET 
      [ContactOID] = @in_ContactOID
      ,[Name] = @in_Name
      ,[Filter] = @in_Filter
      ,[ColPatientName] = @in_ColPatientName
      ,[ColMRN] = @in_ColMRN
      ,[ColAccount] = @in_ColAccount
      ,[ColAdmitting] = @in_ColAdmitting
      ,[ColAttending] = @in_ColAttending
      ,[ColAdmitType] = @in_ColAdmitType
      ,[ColAdmitClass] = @in_ColAdmitClass
      ,[ColLocation] = @in_ColLocation
      ,[ColLastUpdate] = @in_ColLastUpdate
      ,[ColDateOfBirth] = @in_ColDateOfBirth
      ,[ColAge] = @in_ColAge
      ,[ColHeight] = @in_ColHeight
      ,[ColWeight] = @in_ColWeight
      ,[ColGender] = @in_ColGender
      ,[ColPregnant] = @in_ColPregnant
      ,[ColLMP] = @in_ColLMP
 WHERE PatientWorklistOID = @in_WrkListID
	END	
ELSE
	BEGIN
		RAISERROR('PatientWorklistOID doesnt exist',16,1)
	END
	
END
GO
