IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertUpdateAlertNote'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertUpdateAlertNote
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--region [dbo].[hsp_InsertUpdateAlertNote]

------------------------------------------------------------------------------------------------------------------------
-- Generated By:   jnovak using CodeSmith 5.0.0.0
-- Template:       StoredProcedures.cst
-- Procedure Name: [dbo].[hsp_InsertUpdateAlertNote]
-- Date Generated: Saturday, February 07, 2009
------------------------------------------------------------------------------------------------------------------------

/*
sample usage : 

DECLARE
	@AlertNoteOID INT,
	@AlertOID INT,
	@ContactOID INT,
	@NoteText nvarchar(max),
	@CreateDateTime datetime,
	@CreateDateTimeGMTOffset int

 SET @AlertNoteOID = ''
 SET @AlertOID = ''
 SET @ContactOID = ''
 SET @NoteText = ''
 SET @CreateDateTime = ''
 SET @CreateDateTimeGMTOffset = ''

EXEC [dbo].[hsp_InsertUpdateAlertNote] @AlertNoteOID, @AlertOID, @ContactOID, @NoteText, @CreateDateTime, @CreateDateTimeGMTOffset

*/

CREATE PROCEDURE [hsp_InsertUpdateAlertNote]
	@AlertNoteOID INT,
	@AlertOID INT,
	@ContactOID INT,
	@NoteText nvarchar(max),
	@CreateDateTime datetime,
	@CreateDateTimeGMTOffset int
AS

SET NOCOUNT ON

IF EXISTS(SELECT [AlertNoteOID] FROM [dbo].[AlertNote] WHERE [AlertNoteOID] = @AlertNoteOID)
BEGIN
	UPDATE [dbo].[AlertNote] SET
		[AlertOID] = @AlertOID,
		[ContactOID] = @ContactOID,
		[NoteText] = @NoteText,
		[CreateDateTime] = @CreateDateTime,
		[CreateDateTimeGMTOffset] = @CreateDateTimeGMTOffset
	WHERE
		[AlertNoteOID] = @AlertNoteOID
END
ELSE
BEGIN
	INSERT INTO [dbo].[AlertNote] (
		[AlertNoteOID],
		[AlertOID],
		[ContactOID],
		[NoteText],
		[CreateDateTime],
		[CreateDateTimeGMTOffset]
	) VALUES (
		@AlertNoteOID,
		@AlertOID,
		@ContactOID,
		@NoteText,
		@CreateDateTime,
		@CreateDateTimeGMTOffset
	)
END

--endregion
GO
