IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertUpdateAlertNotificationLog'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertUpdateAlertNotificationLog
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--region [dbo].[hsp_InsertUpdateAlertNotificationLog]

------------------------------------------------------------------------------------------------------------------------
-- Generated By:   jnovak using CodeSmith 5.0.0.0
-- Template:       StoredProcedures.cst
-- Procedure Name: [dbo].[hsp_InsertUpdateAlertNotificationLog]
-- Date Generated: Saturday, February 07, 2009
------------------------------------------------------------------------------------------------------------------------

/*
sample usage : 

DECLARE
	@AlertNotificationLogOID INT,
	@AlertOID INT,
	@DateTmeSent datetime,
	@DateTmeSentGMTOffset int,
	@ContactOID INT,
	@CommMethodOID INT,
	@CommMethodSnapshot nvarchar(1000)

 SET @AlertNotificationLogOID = ''
 SET @AlertOID = ''
 SET @DateTmeSent = ''
 SET @DateTmeSentGMTOffset = ''
 SET @ContactOID = ''
 SET @CommMethodOID = ''
 SET @CommMethodSnapshot = ''

EXEC [dbo].[hsp_InsertUpdateAlertNotificationLog] @AlertNotificationLogOID, @AlertOID, @DateTmeSent, @DateTmeSentGMTOffset, @ContactOID, @CommMethodOID, @CommMethodSnapshot

*/

CREATE PROCEDURE [hsp_InsertUpdateAlertNotificationLog]
	@AlertNotificationLogOID INT,
	@AlertOID INT,
	@DateTimeSent datetime,
	@DateTimeSentGMTOffset int,
	@ContactOID INT,
	@CommMethodOID INT,
	@CommMethodSnapshot nvarchar(1000),
	@NextCheck datetime
AS

SET NOCOUNT ON

IF EXISTS(SELECT [AlertNotificationLogOID] FROM [dbo].[AlertNotificationLog] WHERE [AlertNotificationLogOID] = @AlertNotificationLogOID)
BEGIN
	UPDATE [dbo].[AlertNotificationLog] SET
		[AlertOID] = @AlertOID,
		[DateTimeSent] = @DateTimeSent,
		[DateTimeSentGMTOffset] = @DateTimeSentGMTOffset,
		[ContactOID] = @ContactOID,
		[CommMethodOID] = @CommMethodOID,
		[CommMethodSnapshot] = @CommMethodSnapshot,
		[NextCheck] = @NextCheck
	WHERE
		[AlertNotificationLogOID] = @AlertNotificationLogOID
END
ELSE
BEGIN
	INSERT INTO [dbo].[AlertNotificationLog] (
		[AlertNotificationLogOID],
		[AlertOID],
		[DateTimeSent],
		[DateTimeSentGMTOffset],
		[ContactOID],
		[CommMethodOID],
		[CommMethodSnapshot]
	) VALUES (
		@AlertNotificationLogOID,
		@AlertOID,
		@DateTimeSent,
		@DateTimeSentGMTOffset,
		@ContactOID,
		@CommMethodOID,
		@CommMethodSnapshot
	)
END

--endregion
GO
