IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InsertUpdateAlertResponseLog'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InsertUpdateAlertResponseLog
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--region [dbo].[hsp_InsertUpdateAlertResponseLog]

------------------------------------------------------------------------------------------------------------------------
-- Generated By:   jnovak using CodeSmith 5.0.0.0
-- Template:       StoredProcedures.cst
-- Procedure Name: [dbo].[hsp_InsertUpdateAlertResponseLog]
-- Date Generated: Saturday, February 07, 2009
------------------------------------------------------------------------------------------------------------------------

/*
sample usage : 

DECLARE
	@AlertResponseLogOID INT,
	@AlertOID INT,
	@ResponseDateTime datetime,
	@ResponseDateTimeGMTOffset int,
	@ResponseTypeOID INT,
	@Comment nvarchar(2000),
	@ContactOID INT

 SET @AlertResponseLogOID = ''
 SET @AlertOID = ''
 SET @ResponseDateTime = ''
 SET @ResponseDateTimeGMTOffset = ''
 SET @ResponseTypeOID = ''
 SET @Comment = ''
 SET @ContactOID = ''

EXEC [dbo].[hsp_InsertUpdateAlertResponseLog] @AlertResponseLogOID, @AlertOID, @ResponseDateTime, @ResponseDateTimeGMTOffset, @ResponseTypeOID, @Comment, @ContactOID

*/

CREATE PROCEDURE [hsp_InsertUpdateAlertResponseLog]
	@AlertResponseLogOID INT,
	@AlertOID INT,
	@ResponseDateTime datetime,
	@ResponseDateTimeGMTOffset int,
	@AlertStatusId int,
	@Comment nvarchar(2000),
	@ContactOID INT,
	@ProxyContactOID int,
	@NoteVoice image,
	@AlertAckVoice image,
	@ListenedTo datetime,
	@PartialListen int
AS

SET NOCOUNT ON

IF EXISTS(SELECT [AlertResponseLogOID] FROM [dbo].[AlertResponseLog] WHERE [AlertResponseLogOID] = @AlertResponseLogOID)
BEGIN
	UPDATE [dbo].[AlertResponseLog] SET
		[AlertOID] = @AlertOID,
		[ResponseDateTime] = @ResponseDateTime,
		[ResponseDateTimeGMTOffset] = @ResponseDateTimeGMTOffset,
		[AlertStatusId] = @AlertStatusId,
		[Comment] = @Comment,
		[ContactOID] = @ContactOID,
		[ProxyContactOID] = @ProxyContactOID,
		[NoteVoice] = @NoteVoice,
		[AlertAckVoice] = @AlertAckVoice,
		[PartialListen] = @PartialListen
	WHERE
		[AlertResponseLogOID] = @AlertResponseLogOID
END
ELSE
BEGIN
	INSERT INTO [dbo].[AlertResponseLog] (
		[AlertResponseLogOID],
		[AlertOID],
		[ResponseDateTime],
		[ResponseDateTimeGMTOffset],
		[AlertStatusId],
		[Comment],
		[ContactOID],
		[NoteVoice],
		[AlertAckVoice],
		[PartialListen]
	) VALUES (
		@AlertResponseLogOID,
		@AlertOID,
		@ResponseDateTime,
		@ResponseDateTimeGMTOffset,
		@AlertStatusId,
		@Comment,
		@ContactOID,
		@NoteVoice,
		@AlertAckVoice,
		@PartialListen
	)
END

--endregion
GO
