IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InterfaceCreateDefinition'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InterfaceCreateDefinition
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InterfaceCreateDefinition]
(
  @interfaceName               NVARCHAR(8)
, @interfaceDescription        NVARCHAR(200)
, @isModel                     BIT = 0
)
AS
BEGIN

  SET NOCOUNT ON

  DECLARE @definitionOID INT

  SELECT @definitionOID = 0

  IF NOT EXISTS (SELECT 1 FROM InterfaceDefinitions ID WHERE ID.InterfaceName = @interfaceName)
  BEGIN
    -- Get the next InterfaceFieldDefinitionOID to use
    EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'InterfaceDefinition', @nextOID = @definitionOID OUTPUT

    INSERT InterfaceDefinitions
    (
      [InterfaceDefinitionOID]
    , [InterfaceName]
    , [Description]
    , [IsModel]
    )
    VALUES
    (
      @definitionOID
    , @interfaceName
    , @interfaceDescription
    , @isModel
    )
  END
  ELSE
  BEGIN
      -- Definition already exists
      RAISERROR (N'Interface Definition (%s) already defined, NOT able to add again.'
                ,0 -- Severity
                ,1 -- State
                ,@interfaceName); 
  END
END
GO
