IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InterfaceGetAdditionalMsgData'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InterfaceGetAdditionalMsgData
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InterfaceGetAdditionalMsgData]
(
  @msgDefinitionOID INT
)
AS
BEGIN

  SELECT
     LVG.Name        AS 'Category'
    ,LV.Name         AS 'Name'
    ,LV.Abbreviation AS 'Value'
  FROM
    InterfaceMessageDataMap IMDM
      INNER JOIN LookupValueGroups LVG
        ON LVG.LookupValueGroupOID = IMDM.LookupValueGroupOID
	  INNER JOIN LookupValues LV
	    ON LV.LookupValueGroupOID = LVG.LookupValueGroupOID
  WHERE
     IMDM.InterfaceMessageDefinitionOID = @msgDefinitionOID
  ORDER BY
     LVG.Name
    ,LV.SequenceNumber
END
GO
