IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InterfaceGetAdmissionData'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InterfaceGetAdmissionData
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InterfaceGetAdmissionData]
(
 @patientOID INT
,@visitOID   INT
,@entity     NVARCHAR(12)
)
AS
BEGIN
  DECLARE @ids
    TABLE
  (
    PatientOID    INT
  , VisitOID      INT
  , Entity        NVARCHAR(6)
  )

  -- Insert a row into the table variable.  This will ensure we always have
  --   a row of data returned regardless of if the patient/visit exist
  INSERT @ids
    SELECT @patientOID, @visitOID, @entity

  -- Return a single row of data to the caller that contains the data currently
  --   stored in the DB for the patient/visit identifiers passed.
  SELECT
    @patientOID AS PatientOID
  , @visitOID AS VisitOID
  , @entity AS Entity
  , PT.LastName AS LastName
  , PT.FirstName AS FirstName
  , PT.MiddleName AS MiddleName
  , PT.DateOfBirth AS DOB
  , PT.Gender AS Gender
  , PT.Race AS Race
  , PT.Religion AS Religion
  , PT.Height AS Height
  , PT.Weight AS Weight
  , PT.IsPregnant AS IsPregnant
  , PT.LMP AS LMP
  , VT.AdmitDT AS AdmitDT
  , VT.AdmitType AS AdmitType
  , VT.AdmitClass AS AdmitClass
  , VT.LocationOfService AS LocationOfService
  , VT.NurseStation AS NurseStation
  FROM
    @ids ID
      LEFT OUTER JOIN Patients PT
        ON PT.PatientOID = ID.PatientOID
      LEFT OUTER JOIN PatientVisits VT
        ON VT.VisitOID = ID.VisitOID
           AND VT.Entity = ID.Entity
           AND VT.PatientOID = ID.PatientOID
           AND VT.PatientOID = PT.PatientOID
END
GO
