IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InterfaceGetMsgsToProcess'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InterfaceGetMsgsToProcess
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InterfaceGetMsgsToProcess]
(
  @interfaceName NVARCHAR(8)
)
AS
BEGIN

  SELECT
     IMD.InterfaceMessageDefinitionOID   AS 'MsgOID'
    ,IMD.MessageType                     AS 'MsgType'
    ,IMD.EventType                       AS 'EventType'
    ,(SELECT COUNT(1) FROM InterfaceMessageDataMap IMDM
	   WHERE IMDM.InterfaceMessageDefinitionOID = IMD.InterfaceMessageDefinitionOID) AS 'MsgDataGroupCount'
  FROM
	InterfaceDefinitions ID
	  INNER JOIN InterfaceMessageDefinitions IMD
	    ON IMD.InterfaceDefinitionOID = ID.InterfaceDefinitionOID
  WHERE
     ID.InterfaceName = @interfaceName
END
GO
