IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InterfaceGetTransferContactData'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InterfaceGetTransferContactData
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InterfaceGetTransferContactData]
(
 @patientOID INT
,@visitOID   INT
)
AS
BEGIN

  SELECT
    PC.PatientContactOID  AS PatientContactOID
  , PC.PatientContactType AS PatientContactType
  , PC.ContactID          AS ContactID
  , PC.LastName           AS LastName
  , PC.FirstName          AS FirstName
  , PC.MiddleName         AS MiddleName
  , PC.Prefix             AS Prefix
  , PC.Suffix             AS Suffix
  , PC.Title              AS Title
  , @patientOID           AS PatientOID
  , N'VISIT'              AS ContactLevel
  , @visitOID             AS ContactLevelOID
  FROM
    PatientContacts PC
      INNER JOIN VisitContactMap VCM
        ON PC.PatientContactOID = VCM.PatientContactOID
      INNER JOIN PatientVisits PV
        ON PV.VisitOID = VCM.VisitOID
           AND PV.PatientOID = PC.PatientOID
  WHERE
    PC.PatientOID             = @patientOID
    AND PC.PatientContactType = 'ATN'
    AND PV.PatientOID         = @patientOID
    AND PV.VisitOID           = @visitOID
END
GO
