IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_InterfaceSetResultData'))
     BEGIN
          DROP PROCEDURE dbo.hsp_InterfaceSetResultData
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_InterfaceSetResultData]
(
  @examOID           INT
, @resultOID         INT
, @previousResultOID INT
, @resultStatus      NCHAR(1)
, @resultText        TEXT
, @patientOID        INT
)
AS
BEGIN

  DECLARE @examExists BIT

  INSERT PatientResults
    (
      [PatientResultOID]
    , [PreviousResultOID]
    , [ResultStatus]
    , [ResultText]
    , [PatientOID]
    )
    VALUES
    (
      @resultOID
    , @previousResultOID
    , @resultStatus
    , @resultText
    , @patientOID
    )

  IF EXISTS (SELECT 1 FROM ExamResultMap WHERE ExamOID = @examOID)
  BEGIN
    UPDATE
      ExamResultMap
    SET
      ResultOID = @resultOID
    WHERE
      ExamOID = @examOID
  END
  ELSE
  BEGIN
    INSERT ExamResultMap
    (
      [ExamOID]
    , [ResultOID]
    )
    VALUES
    (
      @examOID
    , @resultOID
    )
  END
END
GO
