IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_ResolveInterfaceContactByID_ByOutputVar'))
     BEGIN
          DROP PROCEDURE dbo.hsp_ResolveInterfaceContactByID_ByOutputVar
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_ResolveInterfaceContactByID_ByOutputVar]
(
  @interfaceContactType NVARCHAR(10)
, @interfaceContactID   NVARCHAR(50)
, @contactOID           INT OUTPUT
, @providerRoleOID      INT OUTPUT
)
AS
BEGIN

  SET NOCOUNT ON

  -- Initialize the OUTPUT variables
  SELECT @contactOID = NULL, @providerRoleOID = NULL

  -- Set the Contact OID based on the contact's externalID
  SELECT
    @contactOID = C.ContactOID
  FROM
    Contacts C
  WHERE
    C.ExternalID = @interfaceContactID

  SELECT
    @providerRoleOID = PR.ProviderRoleOID
  FROM
    ProviderRoles PR
      INNER JOIN LookupValues LV
        ON LV.Abbreviation = PR.Name
      INNER JOIN LookupValueGroups LVG
        ON LVG.LookupValueGroupOID = LV.LookupValueGroupOID
  WHERE
    LVG.Name = N'InterfaceContactType'
    AND LV.Name = @interfaceContactType

END
GO
