IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_SelectAlertsNotRespondedTo'))
     BEGIN
          DROP PROCEDURE dbo.hsp_SelectAlertsNotRespondedTo
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_SelectAlertsNotRespondedTo]

AS

SELECT * FROM dbo.Alert al
LEFT JOIN dbo.AlertResponseLog arl
ON arl.AlertOID = al.AlertOID
INNER JOIN AlertLevels levels ON al.AlertLevelOID = levels.AlertLevelOID
INNER JOIN AlertNotificationLog anl ON anl.AlertOID = al.AlertOID
WHERE arl.AlertOID IS NULL
AND DATEADD(minute, levels.EscalationInterval, al.AlertDateTime) < GetDate()
AND GetDate() > anl.NextCheck
GO
