IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_SetInterfacePatientIdentifier'))
     BEGIN
          DROP PROCEDURE dbo.hsp_SetInterfacePatientIdentifier
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_SetInterfacePatientIdentifier]
(
 @identifierOID   INT
,@identifierType  NVARCHAR(3)
,@entity          NVARCHAR(6)
,@ID              NVARCHAR(50)
,@assigningSystem NVARCHAR(50)
,@externalID      NVARCHAR(50)
,@checkDigit      NVARCHAR(1)
)
AS
BEGIN

  DECLARE @identifierExists BIT

  IF EXISTS (SELECT 1 FROM PatientIdentifiers WHERE IdentifierOID = @identifierOID
               AND IdentifierType = @identifierType AND Entity = @entity)
  BEGIN
    SELECT @identifierExists = 1
  END
  ELSE
  BEGIN
    SELECT @identifierExists = 0
  END

  IF (@identifierExists = 1)
  BEGIN
    UPDATE
      PatientIdentifiers
    SET
      ID                = @ID
    , AssigningSystem   = @assigningSystem
    , ExternalID        = @externalID
    , CheckDigit        = @checkDigit
    FROM
      PatientIdentifiers PID
    WHERE
      PID.IdentifierOID      = @identifierOID
      AND PID.IdentifierType = @identifierType
      AND PID.Entity         = @entity
  END
  ELSE
  BEGIN
    INSERT PatientIdentifiers
    (
      IdentifierOID
    , IdentifierType
    , Entity
    , ID
    , AssigningSystem
    , ExternalID
    , CheckDigit
    )
    VALUES
    (
      @identifierOID
    , @identifierType
    , @entity
    , @ID
    , @assigningSystem
    , @externalID
    , @checkDigit
    )
  END
END
GO
