IF EXISTS (SELECT * FROM sysobjects WHERE type in ('P') and id = object_id('dbo.hsp_UsersInsert'))
     BEGIN
          DROP PROCEDURE dbo.hsp_UsersInsert
     END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [hsp_UsersInsert]
	@UserName nvarchar(256),
	@Password nvarchar(128),
	@PasswordSalt nvarchar(128)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @UserOID int
	SELECT @UserOID = 0
	EXEC hsp_GetNextOID_ByOutputVar @oidDescriptor = 'User', @nextOID = @UserOID OUTPUT

	INSERT INTO [dbo].[Users]
			   ([UserOID]
			   ,[UserName]
			   ,[LoweredUserName]
			   ,[Password]
			   ,[PasswordSalt])
		 VALUES
			   (@UserOID
			   ,@UserName
			   ,LOWER(@UserName)
			   ,@Password
			   ,@PasswordSalt)

	SELECT @UserOID
END
GO
