-------------------------------------------------------------------------------------------------
--To add a row to the table...add a new INSERT line to the file
--To change a row in the table...simply change the row's INSERT statement
--To delete a row from the table...remove the INSERT line or comment it out.  
--generated from DBA_generate_inserts
-------------------------------------------------------------------------------------------------
SET NOCOUNT ON
--temporarily disable foreignkeys 
EXEC DBA_ManipulateForeignKeys @operation = 'DISABLE' , @tablename = 'InterfaceDefinitions' , @schemaName = 'dbo'
GO
 
--build a base temp table
SELECT [InterfaceDefinitionOID],[InterfaceName],[Description],[IsModel],[ParentDefinitionOID]
INTO #InterfaceDefinitions
FROM [dbo].[InterfaceDefinitions]
WHERE 1 = 0
GO

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO #InterfaceDefinitions ([InterfaceDefinitionOID],[InterfaceName],[Description],[IsModel],[ParentDefinitionOID])VALUES(1,'MS4','Model MS4 HL7 ADT/ORM/RES Interface Mapping Definition',1,NULL)

SET NOCOUNT OFF
PRINT 'Inserting New Rows (if needed) into [dbo].[InterfaceDefinitions]'
INSERT INTO [dbo].[InterfaceDefinitions]
     ([InterfaceDefinitionOID],[InterfaceName],[Description],[IsModel],[ParentDefinitionOID])
SELECT temp.*
FROM #InterfaceDefinitions temp
LEFT JOIN [dbo].[InterfaceDefinitions] main
     ON temp.InterfaceDefinitionOID = main.InterfaceDefinitionOID
WHERE main.InterfaceDefinitionOID IS NULL;
 
 
 
PRINT 'Deleting Old Rows (if needed) from [dbo].[InterfaceDefinitions]'
DELETE FROM [dbo].[InterfaceDefinitions]
FROM [dbo].[InterfaceDefinitions] main
LEFT JOIN #InterfaceDefinitions temp
ON main.InterfaceDefinitionOID = temp.InterfaceDefinitionOID
WHERE temp.InterfaceDefinitionOID IS NULL;
 
 
 
PRINT 'Updating Rows that have changed from [dbo].[InterfaceDefinitions]'
UPDATE [dbo].[InterfaceDefinitions] SET 
[InterfaceDefinitionOID] = temp.[InterfaceDefinitionOID] ,[InterfaceName] = temp.[InterfaceName] ,[Description] = temp.[Description] ,[IsModel] = temp.[IsModel] ,[ParentDefinitionOID] = temp.[ParentDefinitionOID] 
FROM [dbo].[InterfaceDefinitions] main
JOIN #InterfaceDefinitions temp
ON main.InterfaceDefinitionOID = temp.InterfaceDefinitionOID
JOIN	(
		SELECT InterfaceDefinitionOID, BINARY_CHECKSUM(*) AS bin_checksum FROM #InterfaceDefinitions
		EXCEPT
		SELECT InterfaceDefinitionOID, BINARY_CHECKSUM(*) AS bin_checksum FROM [dbo].[InterfaceDefinitions]
		) checksm
ON main.InterfaceDefinitionOID = checksm.InterfaceDefinitionOID
 
GO
DROP TABLE #InterfaceDefinitions
GO
 
 
 
--enable all foreign keys
EXEC DBA_ManipulateForeignKeys @operation = 'ENABLE' , @tablename = 'InterfaceDefinitions' , @schemaName = 'dbo'
GO
 
 
SET NOCOUNT OFF
