-------------------------------------------------------------------------------------------------
--To add a row to the table...add a new INSERT line to the file
--To change a row in the table...simply change the row's INSERT statement
--To delete a row from the table...remove the INSERT line or comment it out.  
--generated from DBA_generate_inserts
-------------------------------------------------------------------------------------------------
SET NOCOUNT ON
--temporarily disable foreignkeys 
EXEC DBA_ManipulateForeignKeys @operation = 'DISABLE' , @tablename = 'InterfaceMessageDefinitions' , @schemaName = 'dbo'
GO
 
--build a base temp table
SELECT [InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID]
INTO #InterfaceMessageDefinitions
FROM [dbo].[InterfaceMessageDefinitions]
WHERE 1 = 0
GO

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(1,'ADT','A01','Admission',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(2,'ADT','A02','Transfer',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(3,'ADT','A03','Discharge',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(4,'ADT','A04','Admission',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(5,'ADT','A05','Admission',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(6,'ADT','A06','Status Transfer',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(7,'ADT','A07','Status Transfer',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(8,'ADT','A08','Admission',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(9,'ADT','A11','Discharge',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(10,'ADT','A28','Admission',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(11,'ADT','A31','Admission',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(12,'ORM','O01','New Order',1)
INSERT INTO #InterfaceMessageDefinitions ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])VALUES(13,'ORU','R01','Result',1)

SET NOCOUNT OFF
PRINT 'Inserting New Rows (if needed) into [dbo].[InterfaceMessageDefinitions]'
INSERT INTO [dbo].[InterfaceMessageDefinitions]
     ([InterfaceMessageDefinitionOID],[MessageType],[EventType],[Description],[InterfaceDefinitionOID])
SELECT temp.*
FROM #InterfaceMessageDefinitions temp
LEFT JOIN [dbo].[InterfaceMessageDefinitions] main
     ON temp.InterfaceMessageDefinitionOID = main.InterfaceMessageDefinitionOID
WHERE main.InterfaceMessageDefinitionOID IS NULL;
 
 
 
PRINT 'Deleting Old Rows (if needed) from [dbo].[InterfaceMessageDefinitions]'
DELETE FROM [dbo].[InterfaceMessageDefinitions]
FROM [dbo].[InterfaceMessageDefinitions] main
LEFT JOIN #InterfaceMessageDefinitions temp
ON main.InterfaceMessageDefinitionOID = temp.InterfaceMessageDefinitionOID
WHERE temp.InterfaceMessageDefinitionOID IS NULL;
 
 
 
PRINT 'Updating Rows that have changed from [dbo].[InterfaceMessageDefinitions]'
UPDATE [dbo].[InterfaceMessageDefinitions] SET 
[InterfaceMessageDefinitionOID] = temp.[InterfaceMessageDefinitionOID] ,[MessageType] = temp.[MessageType] ,[EventType] = temp.[EventType] ,[Description] = temp.[Description] ,[InterfaceDefinitionOID] = temp.[InterfaceDefinitionOID] 
FROM [dbo].[InterfaceMessageDefinitions] main
JOIN #InterfaceMessageDefinitions temp
ON main.InterfaceMessageDefinitionOID = temp.InterfaceMessageDefinitionOID
JOIN	(
		SELECT InterfaceMessageDefinitionOID, BINARY_CHECKSUM(*) AS bin_checksum FROM #InterfaceMessageDefinitions
		EXCEPT
		SELECT InterfaceMessageDefinitionOID, BINARY_CHECKSUM(*) AS bin_checksum FROM [dbo].[InterfaceMessageDefinitions]
		) checksm
ON main.InterfaceMessageDefinitionOID = checksm.InterfaceMessageDefinitionOID
 
GO
DROP TABLE #InterfaceMessageDefinitions
GO
 
 
 
--enable all foreign keys
EXEC DBA_ManipulateForeignKeys @operation = 'ENABLE' , @tablename = 'InterfaceMessageDefinitions' , @schemaName = 'dbo'
GO
 
 
SET NOCOUNT OFF
