-------------------------------------------------------------------------------------------------
--To add a row to the table...add a new INSERT line to the file
--To change a row in the table...simply change the row's INSERT statement
--To delete a row from the table...remove the INSERT line or comment it out.  
--generated from DBA_generate_inserts
-------------------------------------------------------------------------------------------------
SET NOCOUNT ON
--temporarily disable foreignkeys 
EXEC DBA_ManipulateForeignKeys @operation = 'DISABLE' , @tablename = 'LookupValues' , @schemaName = 'dbo'
GO
 
--build a base temp table
SELECT [LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault]
INTO #LookupValues
FROM [dbo].[LookupValues]
WHERE 1 = 0
GO

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(1,'CA','Cancel Order.','CANCEL',2,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(2,'CH','Child Order.','NEW',2,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(3,'NA','Number Assign.','CONFIRM',2,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(4,'NW','New Order.','NEW',2,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(5,'SC','Order Status Update.','STATUS',2,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(6,'SN','Add On Order.','ADDON',2,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(7,'ATN','Attending physician','AttendingPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(8,'ALT','Alternate physician','AdmittingPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(9,'REF','Referring physician','ReferringPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(10,'ORD','Ordering physician','OrderingPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(11,'CN1','Consulting physician 1','ConsultingPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(12,'CN2','Consulting physician 1','ConsultingPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(13,'CN3','Consulting physician 1','ConsultingPhysician',1,0,NULL,0)
INSERT INTO #LookupValues ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])VALUES(14,'RDG','Reading radiologist','ReadingPhysician',1,0,NULL,0)

SET NOCOUNT OFF
PRINT 'Inserting New Rows (if needed) into [dbo].[LookupValues]'
INSERT INTO [dbo].[LookupValues]
     ([LookupValueOID],[Name],[Description],[Abbreviation],[LookupValueGroupOID],[SequenceNumber],[AdditionalData],[IsDefault])
SELECT temp.*
FROM #LookupValues temp
LEFT JOIN [dbo].[LookupValues] main
     ON temp.LookupValueOID = main.LookupValueOID
WHERE main.LookupValueOID IS NULL;
 
 
 
PRINT 'Deleting Old Rows (if needed) from [dbo].[LookupValues]'
DELETE FROM [dbo].[LookupValues]
FROM [dbo].[LookupValues] main
LEFT JOIN #LookupValues temp
ON main.LookupValueOID = temp.LookupValueOID
WHERE temp.LookupValueOID IS NULL;
 
 
 
PRINT 'Updating Rows that have changed from [dbo].[LookupValues]'
UPDATE [dbo].[LookupValues] SET 
[LookupValueOID] = temp.[LookupValueOID] ,[Name] = temp.[Name] ,[Description] = temp.[Description] ,[Abbreviation] = temp.[Abbreviation] ,[LookupValueGroupOID] = temp.[LookupValueGroupOID] ,[SequenceNumber] = temp.[SequenceNumber] ,[AdditionalData] = temp.[AdditionalData] ,[IsDefault] = temp.[IsDefault] 
FROM [dbo].[LookupValues] main
JOIN #LookupValues temp
ON main.LookupValueOID = temp.LookupValueOID
JOIN	(
		SELECT LookupValueOID, BINARY_CHECKSUM(*) AS bin_checksum FROM #LookupValues
		EXCEPT
		SELECT LookupValueOID, BINARY_CHECKSUM(*) AS bin_checksum FROM [dbo].[LookupValues]
		) checksm
ON main.LookupValueOID = checksm.LookupValueOID
 
GO
DROP TABLE #LookupValues
GO
 
 
 
--enable all foreign keys
EXEC DBA_ManipulateForeignKeys @operation = 'ENABLE' , @tablename = 'LookupValues' , @schemaName = 'dbo'
GO
 
 
SET NOCOUNT OFF
