-------------------------------------------------------------------------------------------------
--To add a row to the table...add a new INSERT line to the file
--To change a row in the table...simply change the row's INSERT statement
--To delete a row from the table...remove the INSERT line or comment it out.  
--generated from DBA_generate_inserts
-------------------------------------------------------------------------------------------------
SET NOCOUNT ON
--temporarily disable foreignkeys 
EXEC DBA_ManipulateForeignKeys @operation = 'DISABLE' , @tablename = 'ProviderRoles' , @schemaName = 'dbo'
GO
 
--build a base temp table
SELECT [ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive]
INTO #ProviderRoles
FROM [dbo].[ProviderRoles]
WHERE 1 = 0
GO

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO #ProviderRoles ([ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive])VALUES(1,'AttendingPhysician',NULL,1,1)
INSERT INTO #ProviderRoles ([ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive])VALUES(2,'AdmittingPhysician',NULL,1,1)
INSERT INTO #ProviderRoles ([ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive])VALUES(3,'ReferringPhysician',NULL,1,1)
INSERT INTO #ProviderRoles ([ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive])VALUES(4,'ConsultingPhysician',NULL,1,1)
INSERT INTO #ProviderRoles ([ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive])VALUES(5,'OrderingPhysician',NULL,1,1)

SET NOCOUNT OFF
PRINT 'Inserting New Rows (if needed) into [dbo].[ProviderRoles]'
INSERT INTO [dbo].[ProviderRoles]
     ([ProviderRoleOID],[Name],[Description],[ReceivesNotification],[IsActive])
SELECT temp.*
FROM #ProviderRoles temp
LEFT JOIN [dbo].[ProviderRoles] main
     ON temp.ProviderRoleOID = main.ProviderRoleOID
WHERE main.ProviderRoleOID IS NULL;
 
 
 
PRINT 'Deleting Old Rows (if needed) from [dbo].[ProviderRoles]'
DELETE FROM [dbo].[ProviderRoles]
FROM [dbo].[ProviderRoles] main
LEFT JOIN #ProviderRoles temp
ON main.ProviderRoleOID = temp.ProviderRoleOID
WHERE temp.ProviderRoleOID IS NULL;
 
 
 
PRINT 'Updating Rows that have changed from [dbo].[ProviderRoles]'
UPDATE [dbo].[ProviderRoles] SET 
[ProviderRoleOID] = temp.[ProviderRoleOID] ,[Name] = temp.[Name] ,[Description] = temp.[Description] ,[ReceivesNotification] = temp.[ReceivesNotification] ,[IsActive] = temp.[IsActive] 
FROM [dbo].[ProviderRoles] main
JOIN #ProviderRoles temp
ON main.ProviderRoleOID = temp.ProviderRoleOID
JOIN	(
		SELECT ProviderRoleOID, BINARY_CHECKSUM(*) AS bin_checksum FROM #ProviderRoles
		EXCEPT
		SELECT ProviderRoleOID, BINARY_CHECKSUM(*) AS bin_checksum FROM [dbo].[ProviderRoles]
		) checksm
ON main.ProviderRoleOID = checksm.ProviderRoleOID
 
GO
DROP TABLE #ProviderRoles
GO
 
 
 
--enable all foreign keys
EXEC DBA_ManipulateForeignKeys @operation = 'ENABLE' , @tablename = 'ProviderRoles' , @schemaName = 'dbo'
GO
 
 
SET NOCOUNT OFF
