-------------------------------------------------------------------------------------------------
--To add a row to the table...add a new INSERT line to the file
--To change a row in the table...simply change the row's INSERT statement
--To delete a row from the table...remove the INSERT line or comment it out.  
--generated from DBA_generate_inserts
-------------------------------------------------------------------------------------------------
SET NOCOUNT ON
--temporarily disable foreignkeys 
EXEC DBA_ManipulateForeignKeys @operation = 'DISABLE' , @tablename = 'SystemRoles' , @schemaName = 'dbo'
GO
 
--build a base temp table
SELECT [SystemRoleOID],[Name]
INTO #SystemRoles
FROM [dbo].[SystemRoles]
WHERE 1 = 0
GO

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO #SystemRoles ([SystemRoleOID],[Name])VALUES(1,'Admin')
INSERT INTO #SystemRoles ([SystemRoleOID],[Name])VALUES(2,'SuperUser')
INSERT INTO #SystemRoles ([SystemRoleOID],[Name])VALUES(3,'User')

SET NOCOUNT OFF
PRINT 'Inserting New Rows (if needed) into [dbo].[SystemRoles]'
INSERT INTO [dbo].[SystemRoles]
     ([SystemRoleOID],[Name])
SELECT temp.*
FROM #SystemRoles temp
LEFT JOIN [dbo].[SystemRoles] main
     ON temp.SystemRoleOID = main.SystemRoleOID
WHERE main.SystemRoleOID IS NULL;
 
 
 
PRINT 'Deleting Old Rows (if needed) from [dbo].[SystemRoles]'
DELETE FROM [dbo].[SystemRoles]
FROM [dbo].[SystemRoles] main
LEFT JOIN #SystemRoles temp
ON main.SystemRoleOID = temp.SystemRoleOID
WHERE temp.SystemRoleOID IS NULL;
 
 
 
PRINT 'Updating Rows that have changed from [dbo].[SystemRoles]'
UPDATE [dbo].[SystemRoles] SET 
[SystemRoleOID] = temp.[SystemRoleOID] ,[Name] = temp.[Name] 
FROM [dbo].[SystemRoles] main
JOIN #SystemRoles temp
ON main.SystemRoleOID = temp.SystemRoleOID
JOIN	(
		SELECT SystemRoleOID, BINARY_CHECKSUM(*) AS bin_checksum FROM #SystemRoles
		EXCEPT
		SELECT SystemRoleOID, BINARY_CHECKSUM(*) AS bin_checksum FROM [dbo].[SystemRoles]
		) checksm
ON main.SystemRoleOID = checksm.SystemRoleOID
 
GO
DROP TABLE #SystemRoles
GO
 
 
 
--enable all foreign keys
EXEC DBA_ManipulateForeignKeys @operation = 'ENABLE' , @tablename = 'SystemRoles' , @schemaName = 'dbo'
GO
 
 
SET NOCOUNT OFF
