/*
this procedure is called from setup.vbs
we assume the ported db failed so we are going to:
	backup the failed ported db for later inspection
	restore the pre-port
	
this will be called from osql with db context of MASTER.  whatever you do...dont put a use statement in this file.  
\1PortingObjects\00_DBA_Backup.sql is responsible for backing up the db.  
	
*/


if exists (select * from sys.objects where object_id = object_id('MXWRestoreFailedPort'))
begin
	drop proc MXWRestoreFailedPort
end
go
create proc MXWRestoreFailedPort
as
begin
	--if we are not running from master, abort
	IF db_name() = 'master' 
	BEGIN
	

		--determine failed dbport to backup
		declare @dbname varchar(2000), @BackupFile varchar(2000) , @exec_str varchar(2000), @fldr varchar(2000), @dtstring varchar(2000)
		select @dbname = dbname , @BackupFile = BackupFile from master..PortingBackup
		select @dtstring = convert(varchar(2000),getdate(),112)
		
		--Parse for the folder name to backup to
		select @fldr = substring(@BackupFile,1,len(@BackupFile)-(charindex('\',reverse(@BackupFile),1)))

		select @exec_str = 'BACKUP DATABASE ' + @DBName + ' TO DISK = ''' + @fldr + '\' + @DBName + '_FAILEDPORTBACKUP_' + @dtstring + '.bak'''
		
		PRINT 'Msg Failed Port Detected...backing up failed port of ' + @DBName
		PRINT @exec_str
		EXEC (@exec_str)
		
		PRINT 'Now restoring pre-port backup'
		SELECT @exec_str = 'ALTER DATABASE ' + @DBName + ' SET SINGLE_USER WITH ROLLBACK IMMEDIATE'
		PRINT @exec_str
		EXEC (@exec_str)
		
		SELECT @exec_str = 'RESTORE DATABASE ' + @DBName + ' FROM DISK = ''' + @BackupFile + ''' WITH REPLACE,RECOVERY'
		PRINT @exec_str
		EXEC (@exec_str)
		
		EXEC('DELETE FROM master..PortingBackup')
		
	END
	ELSE
	BEGIN
		PRINT 'Not running from master...no work to do'
	END

end
go
exec MXWRestoreFailedPort
go

