
if exists (select * from sys.objects where object_id = object_id('CreateDBorBackupExisting'))
begin
	PRINT 'Procedure CreateDBorBackupExisting exists...dropping'
	drop proc CreateDBorBackupExisting
end 
go


PRINT 'Creating Procedure CreateDBorBackupExisting'
GO
CREATE PROC CreateDBorBackupExisting 
(@dbname varchar(200)
,@dbfilepath varchar(200)
,@called_from_porting bit = 1 
,@BackupFileName varchar(max) = NULL OUTPUT
)
AS
/*
--builds a db based on the name and path entered
--will be called from master
EXEC CreateDBorBackupExisting @dbname = 'Notifi', @dbfilepath = 'c:\data'

--can also be called from the app...during ClearTestEntries
--change logic slightly since maxappuser is not sysadmin

*/
BEGIN

DECLARE @dbfile VARCHAR(255)
DECLARE @now VARCHAR(14)
DECLARE @backupfile VARCHAR(255)

declare @dbfileandpath varchar(2000), @dblogandpath varchar(2000), @uniquenessstring varchar(200)
select @dbfileandpath = @dbfilepath + '\' + @dbname + '.mdf' 
select @dblogandpath = @dbfilepath + '\' + @dbname + '.ldf' 
select @uniquenessstring = replace(replace(convert(varchar(200),getdate(),113),':',''),' ','')
declare @result int
exec xp_fileexist @dbfileandpath, @result output 
if @result = 1 
BEGIN
	select @dbfileandpath = substring(@dbfileandpath,1,len(@dbfileandpath)-4) + @uniquenessstring + '.mdf'
END
exec xp_fileexist @dblogandpath, @result output 
if @result = 1 
BEGIN
	select @dblogandpath = substring(@dblogandpath,1,len(@dblogandpath)-4) + @uniquenessstring + '.ldf'
END


declare @exec_str varchar(4000)

if not exists (select * from sys.databases where name = @dbname)
begin
	SELECT @exec_str = 'CREATE DATABASE [' + @dbname + '] ON  PRIMARY 
	( NAME = ''' + @dbname + '_data'', FILENAME = ''' + @dbfileandpath +
	''' , SIZE = 11456KB , MAXSIZE = UNLIMITED, FILEGROWTH = 1024KB )
	 LOG ON 
	( NAME = ''' + @dbname + '_log'', FILENAME = ''' + @dblogandpath +
	''' , SIZE = 3136KB , MAXSIZE = 2048GB , FILEGROWTH = 10%)'
	PRINT @exec_str
	EXEC (@exec_str)
	--will default to that on 2005 anyway...don't want this hardcoded for 2008
	--EXEC dbo.sp_dbcmptlevel @dbname = @dbname, @new_cmptlevel=90
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET ANSI_NULL_DEFAULT ON'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET ANSI_NULLS OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET ANSI_PADDING OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET ANSI_WARNINGS ON'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET ARITHABORT ON'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET AUTO_CLOSE OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET AUTO_CREATE_STATISTICS ON '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET AUTO_SHRINK OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET AUTO_UPDATE_STATISTICS ON'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET CURSOR_CLOSE_ON_COMMIT OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET CURSOR_DEFAULT  GLOBAL'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET CONCAT_NULL_YIELDS_NULL ON '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET NUMERIC_ROUNDABORT OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET QUOTED_IDENTIFIER OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET RECURSIVE_TRIGGERS ON'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET  DISABLE_BROKER '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET AUTO_UPDATE_STATISTICS_ASYNC ON '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET DATE_CORRELATION_OPTIMIZATION OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET TRUSTWORTHY OFF '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET ALLOW_SNAPSHOT_ISOLATION OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + ']  SET PARAMETERIZATION SIMPLE'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET  READ_WRITE'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET RECOVERY SIMPLE '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET  MULTI_USER '
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET PAGE_VERIFY CHECKSUM'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET DB_CHAINING OFF'
	PRINT @exec_str
	EXEC (@exec_str)
	SELECT @exec_str = 'ALTER DATABASE [' + @dbname + '] SET RECOVERY SIMPLE'
	PRINT @exec_str
	EXEC (@exec_str)
	
	
	--PRINT 'Msg IDX filegroup not found, index creation scripts depend on this being present. IDX filegroup can be added via the following command:'
	SELECT @exec_str = 'ALTER DATABASE ' + @dbname + ' ADD FILEGROUP IDX;'
	EXEC (@exec_str)
	declare @idxfileandpath varchar(max)
	select @idxfileandpath = @dbfilepath + '\' + @dbname + '_IDX.ndf' 
	SELECT @exec_str = 'ALTER DATABASE ' + @dbname + ' ADD FILE (NAME = IDX_1 ,FILENAME = ''' + @idxfileandpath + ''' ,SIZE = 100MB ,FILEGROWTH = 100MB) TO FILEGROUP IDX'
	EXEC (@exec_str)
	
	
end
--else
--run this section regardless of net new db or not so restore logic does not fail.  
begin

	PRINT 'DB: ' + @dbname + ' already exists...performing backup'
	SET @now = CONVERT(VARCHAR(8), getdate(), 112) + REPLACE(CONVERT(VARCHAR(6), getdate(), 108), ':', '')
	SELECT @backupfile = @dbfilepath + '\' + @dbname + '_' + @now + '.bak'
	SELECT @exec_str = N'BACKUP DATABASE ' + @dbname + ' TO DISK = ''' + @backupfile + ''''
	PRINT @exec_str
	EXEC (@exec_str)


	IF @called_from_porting = 1
	BEGIN
		--we are running from the porting process
		--build the table master..PortingBackup
		IF EXISTS (select * from master.sys.objects where object_id = object_id('master..PortingBackup'))
		BEGIN
			EXEC('DROP TABLE master..PortingBackup')
		END

		EXEC ('CREATE TABLE master..PortingBackup (BackupFile varchar(2000) NOT NULL
											,DBName varchar(2000));')
		EXEC ('INSERT INTO master..PortingBackup values(''' + @backupfile + ''',''' + @dbname + ''');')
		PRINT 'Logged backup file location to master..PortingBackup'
	END
	ELSE
	BEGIN
		--called from the app, just set the output var
		SELECT @BackupFileName = @backupfile
	END
	
end


--if not exists (select * from sys.filegroups where name = 'PRIMARY')
--BEGIN
--	PRINT 'Msg PRIMARY filegroup not found, clustered index creation scripts depend on this being present'
--END
--if not exists (select * from sys.filegroups where name = 'IDX')
--BEGIN
--	--PRINT 'Msg IDX filegroup not found, index creation scripts depend on this being present. IDX filegroup can be added via the following command:'
--	SELECT @exec_str = 'ALTER DATABASE ' + @dbname + ' ADD FILEGROUP IDX;'
--	EXEC (@exec_str)
--	declare @idxfileandpath varchar(max)
--	select @idxfileandpath = @dbfilepath + '\' + @dbname + '_IDX.ndf' 
--	SELECT @exec_str = 'ALTER DATABASE ' + @dbname + ' ADD FILE (NAME = IDX_1 ,FILENAME = ''' + @idxfileandpath + ''' ,SIZE = 100MB ,FILEGROWTH = 100MB) TO FILEGROUP IDX'
--	EXEC (@exec_str)
--END


END
GO

