'setup.vbs
'runs the entire net new or db upgrade process

'Parameter List
'Parameter                 Description                                                                  Example
'-----------------------------------------------------------------------------------------------------------------------------------
'server_instancename       db server/instancename                                                       dwentzellp\procontractormx
'db_name                   dbname, if it doesnt exist we create it which assumes net new                dave_db
'user_name                 sql username (probably should use sa or equiv)                               sa
'pwd                       sql pwd      
'Logs_folder               folder to store logs for this install/upgrade                                c:\logs
'Language                  language version to install (always use 409 for now)                         409
'Version                   version to install (not used currently)                                      1.6.1
'SQLAccessPath             path to place sql files and backups.  SQLExpress runs as network service
'                          and may not have access to all folders. 


Const ForReading = 1, ForWriting = 2, ForAppending = 8
Const TristateTrue = -1
Const adTypeText   = 2
quote = """"
ErrorEncountered = 0 
SummaryLogFileAndPathName = ""
'when 1 then logs folder will contain text files containing output of PortingTwoPoint0
DebugMode = 0                   
Randomize

'PortingProcessToUse = 1
PortingProcessToUse = 2

set oFso = CreateObject("Scripting.FileSystemObject")



'if we don't pass the params from the command line then lets prompt the user for the variables
'read arguments
Dim iArg, args
Set args = Wscript.Arguments
If args.count = 0 Then
    
    'if we don't pass the params from the command line then lets prompt the user for the variables
    msgbox "Arguments not found on the command line...will prompt for values."
    server_instancename = inputbox("Enter Server and (if necessary) instance name for the SQL Server","DB Installer","(local)\sqlexpress")
    db_name = inputbox("Enter database name. If db does not exist a net new db will be created, else the db will be upgraded","DB Installer")
    user_name = inputbox("sa-equivalent account. Omit parameter for NT authentication","DB Installer")
    pwd = inputbox ("sa-equivalent password. Omit parameter for NT authentication","DB Installer")
    Logs_folder = inputbox("Folder for output logs (check this folder after the port completes for any errors","DB Installer","c:\logs")
    Language = "409"
    Version = "x.x.x"
    SQLAccessPath = "C:\data"
elseIf args.count > 1 Then
    if args.count <> 8 then
        msgbox "Wrong number of args passed in. Usage:  cscript setup.vbs [server_instancename] [db_name] [user_name] [Logs_folder] [Language] [Version] [SQLAccessPath]"
        wscript.quit 1
    end if
 
    'parse out the args
    For iArg = 0 To args.count -1
        server_instancename = args(0)
        db_name = args(1)
        user_name = args(2)
        pwd = args(3)
        Logs_folder = args(4)
        Language = args(5)
        Version = args(6)
        SQLAccessPath = args(7)
    Next
end if 


'additional env setup
'get the path to the script file
sPath = WScript.ScriptFullName
sPath = Left(sPath,Len(sPath)-Len(WScript.Scriptname))

Logs_folder = Logs_folder & "\" & db_name & "\" & LogFolderFormatter (now)
MasterLogFile = Logs_folder & "\db_install.log"
GeneratePath (Logs_Folder)
GeneratePath (SQLAccessPath)
SetNetworkServicePermissions (SQLAccessPath)

'determine if setup.vbs is being run from the installer or manually by a developer
If instr(1,lcase(Wscript.FullName),"wscript") > 1 then
    SetupIsRunViaInstaller = FALSE
Else
    SetupIsRunViaInstaller = TRUE
End If



'Begin Logging
WriteLinetoMasterLogFile ("Begin Porting at: " & cstr(now()))
WriteLinetoMasterLogFile ("Parameter list")
WriteLinetoMasterLogFile ("     server_instancename:  " & server_instancename)
WriteLinetoMasterLogFile ("     db_name:  " & db_name)
WriteLinetoMasterLogFile ("     user_name:  " & user_name)
WriteLinetoMasterLogFile ("     Logs_folder:  " & Logs_folder)
WriteLinetoMasterLogFile ("     Language:  " & Language)
WriteLinetoMasterLogFile ("     Version:  " & Version)
WriteLinetoMasterLogFile ("     SQLAccessPath:  " & SQLAccessPath)
WriteLinetoMasterLogFile ("     SetupIsRunViaInstaller:  " & SetupIsRunViaInstaller)

If UCASE(db_name) = "DemoDB" Then
    Call DemoDB
End If

'Call DBExistence
Call CITPrep
Call CreateDBorBackupExisting

If PortingProcessToUse = 1 Then
    Call Porting
ElseIf PortingProcessToUse = 2 Then
    'this version will not use the DOS batch files
    Call PortingTwoPoint0
End If

'Call UpdateVersionInfo

Call ErrorCheck
'when this occurs:  back up the ported db, then restore the original backup, send DOS errorlevel of 1
Call AbortPortingCheck

If SetupIsRunViaInstaller = FALSE Then
    if ErrorEncountered = 1 Then
        msgbox "Errors occurred during porting...database rolled back...examine the logs for errors."
    else
        msgbox "Porting complete"
    end if
end if


WriteLinetoMasterLogFile ("Done Porting at: " & cstr(now()))
'cleanup
Set oFso = Nothing
wscript.quit(ErrorEncountered)


'Subs and Functions

Public Sub UpdateVersionInfo
    If Version = "x.x.x" Then
        'in this case run 99_DonePorting.txt, this assume we are running from a branch or running setup.vbs manually
        WriteLinetoMasterLogFile ("Porting called with Version of x.x.x, so running 99_DonePorting.txt")
        Call OSQLforFile (sPath & "99_DonePorting.txt" ,MasterLogFile,db_name)
    Else
        'parse Version passed and send to MXW.SetVersionInfo
        WriteLinetoMasterLogFile ("Updating version info table with " & Version)
        
        arrVersion = split(Version,".")
        strQuery = "exec [MXW].[SetVersionInfo] @MajorVersionNumber = " & arrVersion(0) & " ,@MinorVersionNumber = " & arrVersion(1) & " ,@ServicePackNumber = " & arrVersion(2) & " ,@HotFixNumber = " & arrVersion(3) & " ,@BuildNumber = " & arrVersion(4) & " ,@BranchPath = '" & sPath & "'"
        Call OSQLforProcedure (strQuery,MasterLogFile,db_name)
        
    End If
End Sub

Public Sub CITPrep
    'for CIT, set an env variable so we can automate looking at the error logs further
    set shell = CreateObject("wscript.shell")
    set sysEnv = shell.Environment("SYSTEM")
    sysEnv("MasterLogFile") = MasterLogFile
    'msgbox sysEnv("MasterLogFile")
    
End Sub

Public Sub SetNetworkServicePermissions (flder)

    'ensure NetworkService account has permissions to the given folder
    'SQLExpress runs under Network Service context (don't know if this is accurate for Vista) and that is a restricted account so
    'we need to set directory permissions so it has access to create db files and backups.  
    
    'using cacls on Vista likely wont work but I dont have a Vista machine to test on.  
    'will likely need to run %COMSPEC% /c ver
    'Set oStdOutputText = oShellExec.StdOut 
    'Do While Not oStdOutputText.AtEndOfStream 
    '   sText = oStdOutputText.ReadLine 
    'then look for Vista entry and instead from icacls.  
    'It would be nice if MS didnt help us and change these damn tools every release.  
    
    WriteLinetoMasterLogFile ("Public Sub SetNetworkServicePermissions (" & flder & ")")
    
    Set objShell = CreateObject("Wscript.Shell")
    strRun = "%COMSPEC% /c Echo Y| cacls " & quote & flder & quote & " /E /C /G NetworkService:F "
    intError = objShell.Run (strRun,2,TRUE)
    if intError <> 0 Then
        WriteLinetoMasterLogFile ("SetNetworkServicePermissions failed. Not going to stop process since Installer might set permissions for us.")
        'SetErrorEncountered (1)
    End If

End Sub

Public Sub RunAllSQL
    'WIP:  is attempt at moving recursion logic from DBInstall.bat and RunAllSQL.bat to within setup.vbs
    
    
    'dbinstall.bat refactor section
    'prep the logfile
    PortingLogFile = Logs_folder & "\" & db_name & "_DB_Install.log"
    Set oPortLog = oFSO.OpenTextFile(PortingLogFile, ForWriting,TRUE)

    'RunAllSQL.bat refactor section
    Call ProcessFolders (Left(sPath,len(sPath)-1),oPortLog)
    
    oPortLog.Close
    Set oPortLog = Nothing
End Sub
Sub ProcessFolders(folderspec)
    'starting with folderspec it traverses the directory tree merging sql files 
   WriteLinetoMasterLogFile ("   Executing ProcessFolders for " & folderspec & "...")
   

   Set f = oFSO.GetFolder(folderspec)
   Set sf = f.SubFolders
   For Each f1 in sf
        'call recursively until I have no more subfolders
        ProcessFolders (f1.Path)
   Next
   
   'when I have no more subfolders then I want to process .sql files
   Call MergeAndExecuteSQLFiles (folderspec)
   
      
End Sub

Public Sub MergeAndExecuteSQLFiles (fldr)

   MergeFile = "__AllSQL" &  cstr(rnd()) & ".tmp"
   If (oFSO.FileExists(fldr & "\" & MergeFile)) Then
      oFSO.DeleteFile fldr & "\" & MergeFile,TRUE
   End If
   
   strMergeFileAndPath = fldr & "\" & MergeFile
   Set oMergeFile = oFSO.OpenTextFile (strMergeFileAndPath,ForWriting,TRUE,-1)       '-1 creates the file as Unicode
   
    WriteLinetoMasterLogFile ("     Merging the following SQL Files to " & strMergeFileAndPath)

    Set f = oFSO.GetFolder(fldr)
    Set fc = f.Files
    
    For Each f1 in fc
            CurrentFile = f1.name
            CurrentExtension = Right(CurrentFile,3)
		    If UCASE(CurrentExtension) = UCASE("SQL") Then
		        WriteLinetoMasterLogFile ("       " & CurrentFile)
		        
		            oMergeFile.WriteLine "GO"
		            oMergeFile.WriteLine "PRINT '-----------------------------------------------------------------------------'"
		            oMergeFile.WriteLine "PRINT 'Executing SQL file " & fldr & "\" & CurrentFile & "'"
		            oMergeFile.WriteLine "PRINT '-----------------------------------------------------------------------------'"
		            oMergeFile.WriteLine "GO"
		            'oMergeFile.WriteLine "Need to write out file contents here"
		                ReadAllSQLFile = ""
		                'TristateTrue opens our file as unicode
		                Set oReadSQLFile = oFSO.OpenTextFile (fldr & "\" & CurrentFile,ForReading,-1) 
		                ReadAllSQLFile = oReadSQLFile.ReadAll
		                oReadSQLFile.Close
		                Set oReadSQLFile = Nothing
		                
		                'HERE ISSUE:  FileSystemObject not detecting Unicode/ASCII correctly...hence merge files are useless
		                'if we open the file and check if ASC is 255 then we know the file is encoded utf/unicode, and we need to change encoding
		                'when we open the file.  The MergeFile will be / needs to be unicode.  
		                if asc(left(ReadAllSQLFile,1)) = 255 Then
		                    'reread the file 
		                    ReadAllSQLFile = ""
		                    Set oReadSQLFile = oFSO.OpenTextFile (fldr & "\" & CurrentFile,ForReading,,TristateTrue) 
		                    ReadAllSQLFile = oReadSQLFile.ReadAll
		                    oReadSQLFile.Close
		                    Set oReadSQLFile = Nothing
		                End if 
		                oMergeFile.Write ReadAllSQLFile
		                oMergeFile.WriteBlankLines (1)
		            oMergeFile.WriteLine "GO"
	    
		    End If
    Next
    
    oMergeFile.Close
    Set oMergeFile = Nothing
    
    WriteLinetoMasterLogFile "     Executing merged SQL file for " & fldr
    Call OSQLforFile (strMergeFileAndPath,MasterLogFile,db_name)
    
    'delete merged sql file
    If DebugMode = 0 Then 
        If (oFSO.FileExists(fldr & "\" & MergeFile)) Then
          oFSO.DeleteFile fldr & "\" & MergeFile,TRUE
        End If
    End If
    
    'garbage collection
    Set fc = Nothing
    Set f = Nothing

End Sub

Public Sub PortingTwoPoint0

    WriteLinetoMasterLogFile ("Public Sub PortingTwoPoint0")
    ProcessFolders(sPath)
    'RunAllSQL
    WriteLinetoMasterLogFile ("End Sub PortingTwoPoint0")
End Sub


Public Function DetermineAuthentication
    'determines whether we should use integrated or sql auth when connecting with OSQL
    If user_name = "" and pwd = "" then
        DetermineAuthentication = "NT"
    Else
        DetermineAuthentication = "SQL"
    End if 
End Function 

Public Sub OSQLforProcedure (CmdString,LgFile,dbcontext)
    'calls osql for a stored procedure
    'logs output using >> (appends to existing LgFile
    
    strQuery = quote &  CmdString & quote
    
    If DetermineAuthentication() = "SQL" Then
        strCommand = "cmd /C " & quote & quote & sPath & "osql" & quote & " -S" & quote & server_instancename & quote & " -n -w300 -d" & quote & dbcontext & quote & " -U" & quote & user_name & quote & " -P" & quote & pwd & quote & " -Q" & strQuery & " >>" & quote & LgFile & quote & quote 
    else
        strCommand = "cmd /C " & quote & quote & sPath & "osql" & quote & " -S" & quote & server_instancename & quote & " -n -w300 -d" & quote & dbcontext & quote & " -E" & " -Q" & strQuery & " >>" & quote & LgFile & quote & quote 
    end if
    
    intErr = ShellRun(strCommand)
    
End Sub

Public Sub OSQLforFile (FileAndPath,LgFile,dbcontext)
    'calls osql for a file
    'logs output using >> (appends to existing LgFile
    
    strQuery = quote &  CmdString & quote
    
    If DetermineAuthentication() = "SQL" Then  
        strCommand = "cmd /C " & quote & quote & sPath & "osql" & quote & " -S" & quote & server_instancename & quote & " -n -w300 -d" & quote & dbcontext & quote & " -U" & quote & user_name & quote & " -P" & quote & pwd & quote & " -i" & quote & FileAndPath & quote & " >>" & quote & LgFile & quote & quote 
    Else
        strCommand = "cmd /C " & quote & quote & sPath & "osql" & quote & " -S" & quote & server_instancename & quote & " -n -w300 -d" & quote & dbcontext & quote & " -E" & " -i" & quote & FileAndPath & quote & " >>" & quote & LgFile & quote & quote 
    End if 
    
    intErr = ShellRun(strCommand)
    
End Sub

Public Sub AbortPortingCheck
    If ErrorEncountered = 1 Then
        Call OSQLforFile (sPath & "AbortPorting.sql" ,SummaryLogFileAndPathName,"master")
    End if
End Sub


Public Function GeneratePath(FolderPath)
    GeneratePath = False

    If Not oFso.FolderExists(FolderPath) Then
    If GeneratePath(oFso.GetParentFolderName(FolderPath)) Then
        GeneratePath = True
        Call oFso.CreateFolder(FolderPath)
    End If
    Else
        GeneratePath = True
    End If

End Function

Public Sub WriteLinetoMasterLogFile (LineToWrite)
    set objMaster = oFSO.OpenTextFile (MasterLogFile,ForAppending,TRUE)
    objMaster.WriteLine LineToWrite
    objMaster.Close
    Set objMaster = Nothing
End Sub


Public Sub DemoDB
    'if db_name = DemoDB and DemoDB exists do nothing
    'else determine where SQL can access a backup (SQL Express has issues), copy it there, restore it from backup and continue
    'DemoDBLogFile = Logs_folder & "\DemoDB_create.log"
    WriteLinetoMasterLogFile ("Public Sub DemoDB")
    DemoDBLogFile = MasterLogFile
    

    'strValidSQLPath has the valid path that NETWORK SERVICE can read from.  
    'copy the backup file to that path so SQL can RESTORE
    source = strPath & "99DemoData\DemoDB_16207.bak"
    dest = SQLAccessPath & "\DemoDB_16207.bak"
    On Error Resume Next
    oFso.copyfile source,dest,TRUE
    if err.number = 0 then
        'install the DemoDB Existence script
        Call OSQLforFile (sPath & "02_HandleDemoDB.sql",DemoDBLogFile,"master") 
        
        'determine if restore is needed and do it
        'strQuery = "exec HandleDemoDB @filepath = '" & strValidSQLPath & "\'" 
        strQuery = "exec HandleDemoDB @filepath = '" & SQLAccessPath & "\'" 
        Call OSQLforProcedure (strQuery,DemoDBLogFile,"master")
        
        'delete the backup file
        oFso.DeleteFile dest,TRUE
    else
        'there is no backup file available, this occurs because we are running a patch
        'in this case do nothing 
        WriteLinetoMasterLogFile ("Running a patch, or DemoDB backup file to restore was not found.")    
    end if
    On Error GoTo 0 
    

    
    WriteLinetoMasterLogFile ("End Sub")    
End Sub



Public Sub DBExistence
    'calls a sql file to determine if the given db exists or not...creates it if needed.  
    'CreateDBLogFile = Logs_folder & "\db_create_for" & db_name & ".log"
    WriteLinetoMasterLogFile ("Public Sub DBExistence")
    CreateDBLogFile = MasterLogFile

    'compile the procedure
    Call OSQLforFile (sPath & "01_createdb_if_needed.sql",CreateDBLogFile,"master")
    
    'now actually build the db with the compiled procedure
    strQuery = "EXEC master..MaxDBCreate @dbname = '" & db_name & "', @dbfilepath = '" & SQLAccessPath  & "'"
    Call OSQLforProcedure (strQuery,CreateDBLogFile,"master")
    WriteLinetoMasterLogFile ("End Sub")
End Sub

Public Sub CreateDBorBackupExisting
    'calls a sql file to determine if the given db exists or not...creates it if needed, else backs it up.  
    'CreateDBLogFile = Logs_folder & "\db_create_for" & db_name & ".log"
    WriteLinetoMasterLogFile ("Public Sub CreateDBorBackupExisting")
    CreateDBLogFile = MasterLogFile

    'compile the procedure
    Call OSQLforFile (sPath & "CreateDBorBackupExisting.sql",CreateDBLogFile,"master")
    
    'now actually build the db with the compiled procedure
    strQuery = "EXEC master..CreateDBorBackupExisting @dbname = '" & db_name & "', @dbfilepath = '" & SQLAccessPath  & "'"
    Call OSQLforProcedure (strQuery,CreateDBLogFile,"master")
    WriteLinetoMasterLogFile ("End Sub")
End Sub



Public Sub ErrorCheck
    'perform error summary for *.log 
    WriteLinetoMasterLogFile ("Public Sub ErrorCheck")
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set f = fso.GetFolder(Logs_folder)
    Set fc = f.Files

    'create Summary Folder and LogError.txt file
    IF NOT (fso.FolderExists (Logs_folder & "\Summary")) Then
        fso.CreateFolder(Logs_folder & "\Summary")
    End if
    
    CreateDBLogFile = Logs_folder & "\Summary\LogError.txt"
    Set objSummaryLogFile = fso.OpenTextFile(CreateDBLogFile, ForWriting,TRUE)
    'we may need to write addl error info to this file later
    SummaryLogFileAndPathName = CreateDBLogFile
    
    For Each f1 in fc
        CurrentFile = f1.name
        CurrentExtension = Right(CurrentFile,3)
	    If UCASE(CurrentExtension) = "LOG" Then
    
            Call ScanLogFile (Logs_folder & "\" & CurrentFile , objSummaryLogFile)
	    End If
    Next
    
    objSummaryLogFile.Close
    Set objSummaryLogFile = Nothing

    Set f = Nothing
    Set fc = Nothing
    Set fso = Nothing
    
    WriteLinetoMasterLogFile ("End Sub")
End Sub

Public Sub ScanLogFile (LogFileToAnalyze,SummaryFile)
    SummaryFile.WriteLine "Errors from logfile " & LogFileToAnalyze
    SummaryFile.WriteLine  ""
    
    dashes ="============================================================================================"
    stars ="********************************************************************************************"
    SummaryFile.WriteLine dashes
    
    
	'strings we are interested in 
    ErrorString = "Msg " 		'Sql-Error accompanied by Msg
    CopyErrorString= "[Microsoft][ODBC SQL Server Driver]"
    FileOpenErrorString="Cannot open input file"
    CpErrorString="copy in failed"
    LFString = "Login failed"
    osqlString = "Note: osql does not support"
    SNACErr = "[SQL Native Client]"
    
    'a user can close a DOS box manually...errors never get logged nor passed back.  
    'Look for this string which occurs near the end of the porting process, if we don't find it then errors occurred.  
    If PortingProcessToUse = 1 Then
        IndicatesDonePortingString = "Executing SQL file 99_DonePorting.sql"
    Else
        IndicatesDonePortingString = "\99_DonePorting.sql"
    End If
    IndicatesDonePorting = 0
    'open file
    Set oFile = oFSO.OpenTextFile(LogFileToAnalyze, ForReading) 
    Do Until oFile.AtEndOfStream
	    strLine = oFile.ReadLine 
        'increment the line number
	    i  =  i + 1 
	
	    'Check for error strings
	    If  Instr(strLine, ErrorString) OR Instr(strLine, CopyErrorString) OR Instr(strLine, FileOpenErrorString) OR Instr(strLine,CpErrorString) OR Instr(strLine,LFString) OR Instr(strLine,osqlString)  OR Instr(strLine,SNACErr) Then		
	    
		    SummaryFile.WriteLine  ""
		    SummaryFile.WriteLine "	" & strLine
		    SummaryFile.WriteLine  ""
		    
		    SetErrorEncountered (1)
    		
	    End If
	    'Check for DonePorting string
	    If Instr(strLine,IndicatesDonePortingString) Then
	        IndicatesDonePorting = 1
	    End If
    Loop 
    
    oFile.Close
    Set oFile = Nothing
    'DonePorting logging
    If IndicatesDonePorting = 0 Then
        SummaryFile.WriteLine "DonePorting line not found during port, porting did not complete as expected"
        WriteLinetoMasterLogFile ("DonePorting line not found during port, porting did not complete as expected")
        SetErrorEncountered (1)
    End If 

End Sub



Public Function LogFolderFormatter (dt)
    '20080919_1059
    mon = Month(now)
    if len(mon) = 1 then 
        mon = "0" & mon
    end if 
    dy = Day(now)
    if len(dy) = 1 then 
        dy = "0" & dy
    end if 
    str = Year(now) & mon & dy
    str = str & "_" & replace(cstr(formatdatetime(now(),4)),":","")
    LogfolderFormatter = str
End Function

Public Function SetErrorEncountered (val)
    'if its already flagged to 1 dont change it
    If ErrorEncountered = 0 Then 
        ErrorEncountered = val
    end if 
End Function


Public Function ShellRun (strCmd)

    Set objShell = CreateObject("Wscript.Shell")
    
    If SetupIsRunViaInstaller = TRUE Then
        intError = objShell.Run (strCmd,0,TRUE)
    Else
        intError = objShell.Run (strCmd,,TRUE)
    End If 
    
    Set objShell = Nothing
    ShellRun = intError
    
End Function

